

/* Version vom 20.10.2011
2.12
  Wartezeit fr Displayinitialisierung verkrzt
  Spruch bei Programmende in unterer Zeile
  Ausgebaut: Pumpe an bei viel zu hohem Wasserstand

2.11
  Bei Fehler Displaytext zyklisch senden
  Beim Schleudern Pumpe dauernd an
  Pumpe an bei viel zu hohem Wasserstand
  Umlaute eingebaut

2.10
  Selbstreinigungsprogramm "Biofilm" eingebaut
2.9
  Anzeige des gewhlten Programms im Klartext
  RS232 jetzt mit 4800 Baud (8N2) und Ausgabe auf Display optimiert
  

TODO:
  Hardware Fehlererkennung: 
    - Tr nicht zu (unwichtig, denn dann luft einfach nix.)
    - Motor berlastet (Wsche verklemmt)


Nicht implementiert:
  Splstopp
  Wolle

*/

/*
Realisiert mit ATmega168-20PU - 16.384MHz


Ausgnge zur Waschmaschine:
  3 Magnetventile
  3 Motorrelais
  1 Heizungsrelais
  1 Motortriac
  1 Trverriegelung
  1 Laugenpumpe

Pinbelegung (DIL-28 Version)

                PC6 1  28 PC5   Rechts
            Rx  PD0 2  27 PC4   Triac Motor
            Tx  PD1 3  26 PC3   Ventil Hauptwasch
  Nulldurchgang PD2 4  25 PC2   Ventil Vorsplen 
                PD3 5  24 PC1   Ventil Weichspl 
Trverriegelung PD4 6  23 PC0   Relais Heizung
                VCC 7  22 GND
                GND 8  21 AREF
             Q1 PB6 9  20 AVCC
             Q2 PB7 10 19 PB5   SCK   
                PD5 11 18 PB4   MISO  
        Schnell PD6 12 17 PB3   MOSI  
                PD7 13 16 PB2   Laugenpumpe
          Tacho PB0 14 15 PB1   Links



Die Magnetventile sind:
 - Rosa, Weichspl, mittlere Kammer 
 - Schwarz, Hauptwasch, linke Kammer
 - Weiss, Vorspl, rechte Kammer

Ausgnge:
    PB1  Links
    PC5  Rechts
    PC4  Triac Motor
    PC2  Ventil Vorsplen
    PC1  Ventil Weichsplen
    PC3  Ventil Hauptwasch 
    PC0  Heizung
    
    PD1  Tx  (Infos zum PC)
    PD4  Trverriegelung
    PD6  Schnell

Eingnge:
    PB0     Tacho          (ICP1)
    PD0     RX  (Daten vom Kleinhirn)
    PD2     Nulldurchgang  (INT0)

T0 - 8Bit:  Beim Start: Zeitbasis (62,5Hz), spter unbenutzt
T1 - 16Bit: zhlt mit prescaler=8. Mit Input-Capture Unit. Tachopulse auf ICP1(PB0).
T2 - 8bit:  Triac-Zndung. Wird im Nulldurchgang gestartet, stoppt sich selbst.

INT0: Nulldurchgang (100Hz)  (PD2)
ICP1: Tacho (0..2500Hz)     (PB0) Es wird das Tachosignal auf die InputCaptureUnit von Timer1 gelegt.


Bedienung mit Drehschalter.
============================
Steht der Schalter oben, ist die Maschine stromlos.
Dreht man den Schalter auf einen beliebige andere Position, luft das Programm los.
Nach dem anfnglichem Abpumpen von Kondenswasser wird die Drehschalterstellung ausgelesen
und dann das gewhlte Programm bis zum Ende durchlaufen und dann endlos gewartet.
Um das Programm zu ndern, muss der Schalter auf AUS gestellt werden, dann kurz warten 
und anschlieend kann das neue Programm gewhlt werden.


Die SPS Programme:
  spsSekundentakt - darin die SPS-Unterprogramme
      spsWaschablauf (Der eigentliche Ablauf)
      spsSpuelgang
      spsWeichspuelgang
      spsTrocknen
      spsAbpumpen
      spsHeizung
      spsAbkuehlen

  spsReversieren
  spsSchleudern 
  spsMotor 


Drehschalter der Originalmaschine
==================================
Pin1: Common - GND 
Pin2: 1              (Pin 2..6 nutzten interne Pull-Up Widerstnde vom ATmega)
Pin3: 2
Pin4: 4
Pin5: 8
Pin6: 16


Schalter oben:Pos=0   1 nach rechts: Pos=1   1 nach lins: Pos=20
Codierung:
Pos   65432    Wert
0     10000     16
1     10011     19 
2     11010     26
3     11001     25
4     11000     24
5     10101     21
6     01111     15
7     01101     13
8     10001     17
9     10110     22
10    00101      5
11    11100     28
12    00110      6
13    01100     12
14    00100      4
15    01011     11
16    10010     18
17    10111     23
18    11011     27
19    11101     29
20    11110     30


Phasenanschnittsteuerung des Motor-Triacs ber T2-ISR  (PB3)
==========================================

Motordrehzahl:

  Abschtzung der Tacho-Frequenzen:
  Untersetzung Motor:Trommel = 31:3
  Tacho gibt 8 Pulse pro Motorumdrehung, also 82,66 Pulse je Trommelumdrehung
  Bei langsamster Drehzahl (Trommel dreht mit 30 1/min; 8 Pulse/Motordrehung):
     Pulse mit 41Hz  (Motor:  5 1/s, 300 1/min; )
  Bei max. Drehzahl (Tromel 1500 1/min; 8 Pulse/Motordrehung): 
     Pulse mit 2066Hz (Motor 12000 1/min; 200 1/s)

  CPU-Takt=16.384MHz
  Prescaler=256
  Zhlfrequenz:64KHz an Timer T1 (16bit)
  bei 41Hz: 1561
  bei 2066Hz: 30


mgliche Fehlererkennung:
  - Trommelblockade:  wenn Motorregler beim Reversieren an Anschlag geht 
  - Durchlegierte TRIACs:
    - Magnetventile: Wasserpegel steigt
    - Pumpe          Spannung, auch wenn abgeschaltet
    - Motor          Spannung, auch wenn abgeschaltet
  - hngendes Relais
    - "schnell" immer an
        bliche Reglerwerte beim Reversieren vllig anders  
    - "schnell" immer aus 
        Regler beim Schleudern auf Anschlag, aber Drehzahl viel zu niedrig
    - "Rechts" oder "Links": immer aus:
        Drehzahl bleibt 0 beim Reversieren, Kann auch defekter Tacho sein. 
    - Heizung
        Temperatur steigt nicht
        Temperatur steigt immer weiter 

  - Tacho defekt
      Drehzahl bleibt 0 beim Reversieren. Kann auch Relais oder Motor sein.
  - Tr nicht zu     
      Keine Spannung 10s nach Verriegelung
  - Magnetventil ffnet nicht
      Wasserspiegel steigt nicht bei diesem Ventil (SW knnte ein anderes probieren)
  - Magnetventil schliet nicht dicht
      Wasserspiegel steigt stndig
  - Wasserhahn zu:
      Wasserspiegel steigt nicht bei Vorwasch und nicht bei Hauptwasch
   
  - Druckdose defekt
      Frequenz ausserhalb von 34..44Hz. Z.B.: Keine Pulse
  - Netzproblem
      Keine Nulldurchgangsinterrupts (hm, das wre wohl eher ein Defekt auf der Hauptplatine)
  - Temperaturfhler defekt
      Wert viel zu hoch/zu niedrig (ber 100C, unter -10C)
  - Hirntod
      keine Daten vom Kleinhirn 

  
  - Trommel blockiert/gebremst
      Triac beim Reversieren auf Anschlag

  Bisher nicht erkennbar:
    - berschumen
    - Undichtes Gehuse


Fehler:    (Die meisten werden noch nicht erfasst)

  1     Tr nicht zu      oder Verriegelung oder Verriegelungsansteuerung defekt
  2     Wassermangel      oder Magnetventl oder Magnetventilansteuerung defekt oder Pumpe luft permanent
  3     Frost             oder Thermometer defekt
  4     Pumpe blockiert   oder Abfluss verstopft oder Ansteuerung defekt
  5     Trommel dreht nicht. Tacho oder Motor oder Relais oder Triac defekt
  6     Wsche verklemmt  
  7     Keine Daten vom Kleinhirn

*/

//Setze TEST auf 1 um Waschablufe zur Algorithmenerprobung stark abzukrzen, auf 0 um Wsche zu waschen
#define TEST 0


#define F_CPU 16384000UL  /* CPU clock in Hertz */

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
#include <util/delay.h> 
#include <stdint.h>
#include <string.h> //memcpy

//Abkrzungen fr einfache Datentypen
#define U8  uint8_t
#define U16 uint16_t
#define I8  int8_t
#define I16 int16_t
#define I32 int32_t
#define U32 uint32_t

//Potenzen von 2
#define BIT0 1
#define BIT1 2
#define BIT2 4
#define BIT3 8
#define BIT4 16
#define BIT5 32
#define BIT6 64
#define BIT7 128

//Digitale Ausgnge
#define  TUERVERRIEGELUNG_aus PORTD &=~BIT4      
#define  TUERVERRIEGELUNG_ein PORTD |= BIT4      

#define  TROMMELMOTOR_TRIAC_aus PORTC &=~BIT4      
#define  TROMMELMOTOR_TRIAC_ein PORTC |= BIT4      

#define  RELAIS_RECHTS_aus PORTC &=~BIT5      
#define  RELAIS_RECHTS_ein PORTC |= BIT5      

#define  RELAIS_LINKS_aus PORTB &=~BIT1
#define  RELAIS_LINKS_ein PORTB |= BIT1  

#define  RELAIS_SCHNELL_aus PORTD &=~BIT6   
#define  RELAIS_SCHNELL_ein PORTD |= BIT6    

#define  RELAIS_HEIZUNG_aus PORTC &=~BIT0
#define  RELAIS_HEIZUNG_ein PORTC |= BIT0    

#define VENTIL_VORWASCH_aus PORTC &=~BIT2
#define VENTIL_VORWASCH_ein PORTC |= BIT2

#define VENTIL_HAUPTWASCH_aus PORTC &=~BIT3
#define VENTIL_HAUPTWASCH_ein PORTC |= BIT3

#define VENTIL_WEICHSPUEL_aus PORTC &=~BIT1
#define VENTIL_WEICHSPUEL_ein PORTC |= BIT1

#define LAUGENPUMPE_aus PORTB &=~ BIT2
#define LAUGENPUMPE_ein PORTB |= BIT2

//#define DEBUG_L PORTD &=~BIT4
//#define DEBUG_H PORTD |= BIT4 
#define DEBUG_L {}
#define DEBUG_H {}


//Feste Registerzuweisung um Code in IRQ schneller zu machen
register I16  v      asm("r6");
register I16  d      asm("r8");
register U16  p0     asm("r12");
register U16  valt   asm("r16");


//----------------------------------- Daten vom Kleinhirn ---------------------------

typedef struct {  //Telegramm vom Kleinhirn
  U8  FF;  //Start-
  U8  FE;  //      Zeichen
  I16 wasserstand;
  U16 temperatur;
                 //Analogeingnge des Kleinhirns:
  U8   a;          // PC1    Spannung Tr   
  U8   b;          // PC2    Spannung Motor 
  U8   c;          // PC3    Netzspannung1  
  U8   d;          // PC4    Netzspannung2  (hinter Trschalter)
  U8   e;          // PC5    Spannung Pumpe 
  U8   digitalInputs;
  U8  cr;  
  U8  lf;  
}TkleinhirnRecord;


//Temperaturen vom Kleinhirn in 1/10C
#define TEMPERATUR_0 0
#define TEMPERATUR_20 200
#define TEMPERATUR_22 220
#define TEMPERATUR_25 250
#define TEMPERATUR_30 300
#define TEMPERATUR_40 400
#define TEMPERATUR_50 500
#define TEMPERATUR_60 600
#define TEMPERATUR_65 650
#define TEMPERATUR_85 850



//Wasserstnde vom Kleinhirn. 
//0x2cac ist ein typischer Wert bei leerer Trommel, der aber je nach Luftdruck schwankt
//Daher wird beim Start abgepumpt und der aktuelle "Leer-Wert" gemessen
U16 wasserstandWerte[9]={
  0,  // 0x2cac - 0x2cac, //0  Leer 
  374,// 0x2e22 - 0x2cac, //1 nach 20s Wassereinlass
  332,// 0x2df8 - 0x2cac, //2  Trommelboden nass
  707,// 0x2f6f - 0x2cac, //3  Trommelkante
  851,// 0x2fff - 0x2cac, //4  Dichtung  (Normalwasserstand)
  1015,// 0x30A3 - 0x2cac, //5  15mm ber Dichtung  (nach 80s Wassereinlauf)
  1284,// 0x31b0 - 0x2cac, //6  Hoher Wasserstand (Ende Glasschrgenende)
  1694,// 0x334a - 0x2cac  //7  sehr hoher Wasserstand (70mm ber Dichtung)
  1900                     //8  so hoch sollte das Wasser nie steigen. 
};


#define WASSERSTAND_1             wasserstandWerte[2] //nach ca. 20s Wasser einlassen (Pumpensumpf gefllt)
#define WASSERSTAND_NORMAL        wasserstandWerte[4] //Buntwsche. ca. 6-7cm ber Trommelboden
#define WASSERSTAND_ERHOEHT       wasserstandWerte[6] //ca. 10cm ber Bullaugenunterkante
#define WASSERSTAND_SPUELEN       wasserstandWerte[6] //ca. 10cm ber Bullaugenunterkante
#define WASSERSTAND_SPUELEN_HOCH  wasserstandWerte[7] //ca. Mitte Bullauge
#define WASSERSTAND_WOLLE         wasserstandWerte[7] //ca. Mitte Bullauge
#define WASSERSTAND_ZU_HOCH       wasserstandWerte[8] 



//----------------------------------- Texte fr das Display---------------------------

//Displaytexte obere Zeile
                                 //123456789 123456789| 
const char textHaupt0[] PROGMEM = "Tabeas Waschmaschine";
const char textHaupt1[] PROGMEM = "Hauptwsche";
const char textHaupt2[] PROGMEM = "Splgang 1";
const char textHaupt3[] PROGMEM = "Splgang 2";
const char textHaupt4[] PROGMEM = "Splgang 3";
const char textHaupt5[] PROGMEM = "Schleudern";
const char textHaupt6[] PROGMEM = "Fertig.";
const char textHaupt7[] PROGMEM = "Extra";
const char textHaupt8[] PROGMEM = "Weichsplen";

PGM_P pgm_texteHaupt[9] PROGMEM = {
    textHaupt0,
    textHaupt1,
    textHaupt2,
    textHaupt3,
    textHaupt4,
    textHaupt5,
    textHaupt6,
    textHaupt7,
    textHaupt8
};

//Displaytexte untere Zeile (Wird mit 2 fhrenden Leerzeichen ausgegeben)
                               //123456789 123456789| 
const char textNeben0[] PROGMEM = " ";
//const char textNeben1[] PROGMEM = "Wassereinlauf";
const char textNeben1[] PROGMEM = "Wasser marsch!";
const char textNeben2[] PROGMEM = "Abkhlen";
const char textNeben3[] PROGMEM = "Aufheizen";
const char textNeben4[] PROGMEM = "Warmwaschen";
const char textNeben5[] PROGMEM = "hin und her"; //Nachwaschen
const char textNeben6[] PROGMEM = "Wasser raus"; //Trocknen
const char textNeben7[] PROGMEM = "Durchwalken";
const char textNeben8[] PROGMEM = "Abpumpen";
const char textNeben9[] PROGMEM = "vorwrmen";
const char textNeben10[] PROGMEM = "Tr verriegeln";

PGM_P pgm_texteNeben[11] PROGMEM = {
    textNeben0,
    textNeben1,
    textNeben2,
    textNeben3,
    textNeben4,
    textNeben5,
    textNeben6,
    textNeben7,
    textNeben8,
    textNeben9,
    textNeben10
};

const char textStart[] PROGMEM = "Tabeas Waschmaschine";


                                //123456789 123456789| 
const char textSpruch1[] PROGMEM = "Tabea gewinnt";
const char textSpruch2[] PROGMEM = "Stefan gewinnt";
const char textSpruch3[] PROGMEM = "Alles blitzsauber";
const char textSpruch4[] PROGMEM = "ganz kuschelig";
const char textSpruch5[] PROGMEM = "Du bist dran...";
const char textSpruch6[] PROGMEM = "hol alles raus";
const char textSpruch7[] PROGMEM = "Wasser abdrehen";
const char textSpruch8[] PROGMEM = "Tabea was here...";

PGM_P pgm_texteSpruch[8] PROGMEM = {
    textSpruch1,
    textSpruch2,
    textSpruch3,
    textSpruch4,
    textSpruch5,
    textSpruch6,
    textSpruch7,
    textSpruch8
};



//Displaytexte im Fehlerfall
                                 //123456789 123456789| 
const char textError0[]  PROGMEM = "Fehler:";
const char textError1[]  PROGMEM = "Kein Wasser/Tr";
const char textError2[]  PROGMEM = "Pumpenfehler";
const char textError3[]  PROGMEM = "Ventilfehler Haupt";
const char textError4[]  PROGMEM = "Wasser steigt nicht";
const char textError5[]  PROGMEM = "Ventilfehler Vorw.";
const char textError6[]  PROGMEM = "Motorregelung";
const char textError7[]  PROGMEM = "Kleinhirn stumm";
const char textError8[]  PROGMEM = "Thermofhler";
const char textError9[]  PROGMEM = "Druckmessdose";
const char textError10[] PROGMEM = "Kein Nulldurchgang";


PGM_P pgm_texteError[11] PROGMEM = {
    textError0,
    textError1,
    textError2,
    textError3,
    textError4,
    textError5,
    textError6,
    textError7,
    textError8,
    textError9,
    textError10
};
    
// Krzel fr Textzuweisungen (Nebentexte und Haupttexte)
#define NT_Leer           g.nebentextIndex=0
#define NT_Wassereinlauf  g.nebentextIndex=1
#define NT_Abkuehlen      g.nebentextIndex=2
#define NT_Aufheizen      g.nebentextIndex=3
#define NT_Warmwaschen    g.nebentextIndex=4
#define NT_Nachwaschen    g.nebentextIndex=5
#define NT_Trocknen       g.nebentextIndex=6
#define NT_Walken         g.nebentextIndex=7
#define NT_Pumpen         g.nebentextIndex=8
#define NT_Anwaermen      g.nebentextIndex=9
#define NT_verriegeln     g.nebentextIndex=10
#define NT_Spruch         g.nebentextIndex=99 


#define HT_Hauptwaesche  g.haupttextIndex=1
#define HT_Spuelgang1    g.haupttextIndex=2
#define HT_Spuelgang2    g.haupttextIndex=3
#define HT_Spuelgang3    g.haupttextIndex=4
#define HT_Schleudern    g.haupttextIndex=5
#define HT_Ende          g.haupttextIndex=6
#define HT_Sonder        g.haupttextIndex=7
#define HT_Weichspuel    g.haupttextIndex=8


//Displaytexte der Drehschalterstellungen (also des gewhlten Waschprogramms)

//Gradzeichen ist beim HD44780 eigentlich 0xDF  (223): '', aber das Display zeigt das Zeichen fr $AF
//Bei diesem Display liegt das Gradzeichen auf 0xE7 (231): ''.
//@H ist ein Steuercode, der an den Anfang der 2. Zeile schaltet
const char textProgramm0[] PROGMEM = "AUS";
//                                    123456789 1234569789
const char textProgramm1 [] PROGMEM = "Buntwsche 85C@HSchleudern 1200";
//const char textProgramm2 [] PROGMEM = "Buntwsche 60C@HSchleudern 1200";
const char textProgramm2 [] PROGMEM = "Tabeas 40C Turbo@HSchleudern  900";
const char textProgramm3 [] PROGMEM = "Utes super 60C@HSchleudern  1200";
const char textProgramm4 [] PROGMEM = "Buntwsche 40C@HSchleudern 1200";
const char textProgramm5 [] PROGMEM = "Buntwsche 40C@HSchleudern  700";
const char textProgramm6 [] PROGMEM = "Stefans 30C Hemden@HSchleudern 700";
const char textProgramm7 [] PROGMEM = "Pflegeleicht 60C@HSchleudern  900";
const char textProgramm8 [] PROGMEM = "Pflegeleicht 50C@HSchleudern  900";
const char textProgramm9 [] PROGMEM = "Pflegeleicht 40C@HSchleudern  900";
const char textProgramm10[] PROGMEM = "Pflegeleicht 30C@HSchleudern  900";
const char textProgramm11[] PROGMEM = "Feinwsche 40C@HSchleudern  600";
const char textProgramm12[] PROGMEM = "Feinwsche 30C@HSchleudern  600";
const char textProgramm13[] PROGMEM = "Selbstreinigung 85C@Hkeine Wsche!";
const char textProgramm14[] PROGMEM = "Wolle 30C@HSchleudern  600";
const char textProgramm15[] PROGMEM = "Wolle kalt @HSchleudern  600";
const char textProgramm16[] PROGMEM = "Feinsplen@HSchleudern  600";
const char textProgramm17[] PROGMEM = "Splen@HSchleudern  900";
const char textProgramm18[] PROGMEM = "Abumpen@H...alles was geht";
const char textProgramm19[] PROGMEM = "Schleudern 1200";
const char textProgramm20[] PROGMEM = "Schleudern  600";

PGM_P pgm_texteProgramm[21] PROGMEM = {
    textProgramm0,
    textProgramm1,
    textProgramm2,
    textProgramm3,
    textProgramm4,
    textProgramm5,
    textProgramm6,
    textProgramm7,
    textProgramm8,
    textProgramm9,
    textProgramm10,
    textProgramm11,
    textProgramm12,
    textProgramm13,
    textProgramm14,
    textProgramm15,
    textProgramm16,
    textProgramm17,
    textProgramm18,
    textProgramm19,
    textProgramm20
};

//----------------------------------- Strukturdeklarationen ---------------------------

//Kleinhirn Empfangspuffergre
#define RX_BUFFERSIZE 30  // muss >14 sein

//Wir haben insgesamt 1024 Bytes SRAM - reichlich Platz, um alle Variablen statisch zu halten

//Der Einfachheit halber: viele globale Variablen
//Wegen der bersicht: alle in einer Struktur Tglob zusammengefasst
typedef struct {

  U8  haupttextIndex;
  U8  nebentextIndex;
  U8  debugstatus;
  U8  error;  //0=kein Fehler, sonst: Fehlernummer
  U8  tic10ms; //Aus Netzfrequenz
  U8  tic112ms; //Vom Timer 0
  U16 auUmlauf[83];
  U8  indexUmlauf;
  U8  uptimeM; // Minuten seit einschalten

  I16 iTacho0;
  I16 iTacho1;
  I16 iTachoDelta0;
  I16 iTachoDelta1;

  U8  next100ms;        // wird alle 100ms auf 1 gesetzt (hngt an Netzfrequenz)

  U8  Motortriacfreigabe;
  U8  Reglerschritt;
  U8  cInvalid;
  U8  cSlot;
  
  U8 RxBuffer[RX_BUFFERSIZE];
  U8 RxBufferWrite;
  U8 RxBufferRead;

  TkleinhirnRecord kleinhirnRecord;
  TkleinhirnRecord kleinhirnRxRecord;
  U8 kleinhirnSendet;   //Fr Timeoutbehandlung von Kleinhirntelegrammen
  U8 programmNochNichtFestgelegt;  //Solange >0  steht der Drehschalter noch nicht lange genug still
  U8 empfangeneTelegramme; //Vom Kleinhirn
  char *pSendChar; //Zur Textausgabe in main()
  
  U8 spruch; // Zuflliger Spruch wenn fertig


  //----Variablen der einzelnen SPS-Funktionen----

  struct{
    //Public:
    U8 anzahl;    //Enabled, wenn >0
    U8 pausenzeit;
    U8 drehzeit;
    U8 wasserstandsanpassung; //Wenn >0, wird am Pausenende ggf. Wasser via Hauptventil nachgefllt
    U8 inPause;        //Zum Synchronisieren mit Abkhlen/Abpumpen
  }reversieren;

  struct{
    //Public:
    I8 nachlaufzeit;    //Enabled, wenn >0
    U8 intervallpumpen; //Gibt Pausenzeit an (Pumpzeit ist 7s). Enabled, solange >0 und nachlaufzeit>0
    U8 extrapumpen;     //Pumpe einmalig 15s
  }abpumpen;

  struct{
    //Public:
    U16 waschtemperatur; //NICHT in Grad, sondern als ADC-Konstanten. 
    U8  Wasserniveau;    //0=normal 1=hoch 2=Wolle
    U8  spuelgaenge;     //Normal 3, bei Schnellwaesche 2
    I16 wasserstandSoll;
    U16 anfangswasserstand;
    U16 frischwassertemperatur;
    I16 endschleuderdrehzahl;     // in 1/min
    U8  schnellwaesche;
    U8  fertig;
  }waschablauf;

  struct{
    U16 solltemperatur;
    U8  solltemperaturErreicht;
  }heizungsregelung;

  struct{
    I16 solldrehzahl;
    I16 istdrehzahl;
    U8  cZuendzeit; //0..38 (Motortriac Zndzeitpunkt)
    U8  aufloesung;  //0: 120 fr 30 1/min   1: 30 fr 30 1/min
  }motor;

  struct{
    I16 enddrehzahl;     // in 1/min
    I16 schleuderdauer;  // in Sekunden
    U8  freigabe:1;
    I16 unwucht; 
    I16 streuung; 
    U8  ablaufSchleudern;
  }schleudern;

  struct{
    I16 enddrehzahl;     // in 1/min
    U8  freigabe:1;
  }trocknen;  //Abpumpen, Anschleudern und Schleudern

  struct{
    U8 freigabe:1;
  }abkuehlen;
  
  struct{
    U8 freigabe:1;
  }biofilm;
  
  struct{
    U8 freigabe:1;
    U8 spueldauer;
  }spuelgang;
	
  struct{
    U8 freigabe:1;	
    U8 spueldauer;
  }weichspuelgang;


}Tglob;

//Alle globalen Var in einer Struct deklarieren
volatile  Tglob g;
//Diese nicht als volatile:
char txMsg[160];  //Hier landen die auszugebenden Texte fr das Display


//Prototypen:
void spsWaschablauf(void);
void spsSpuelgang(void);
void spsWeichspuelgang(void);
char * showval(char * buffer, const char  * txt, int len, int val );


//--------------------------------------------------------
char * showTemp1(char * buffer, const char  * txt, int messwert){
//--------------------------------------------------------
//Temperatur mit 1 Nachkommastelle in buffer (ohne nachfolgendes Leerzeichen)
    while ((*buffer++ = *txt++));  //Txt kopieren
    buffer--;
    *buffer++ = (messwert / 100) + '0'; 
    messwert %= 100;

    *buffer++ = (messwert / 10) + '0'; 
    *buffer++ = '.';
    *buffer++ = (messwert % 10) + '0'; 
    *buffer=0;
    return buffer; 
} 

//--------------------------------------------------------
char * showTemp0(char * buffer, const char  * txt, int messwert){
//--------------------------------------------------------
//Temperatur ohne Nachkommastelle in buffer (ohne nachfolgendes Leerzeichen)
    while ((*buffer++ = *txt++));  //Txt kopieren
    buffer--;
    *buffer++ = (messwert / 100) + '0'; 
    messwert %= 100;

    *buffer++ = (messwert / 10) + '0'; 
    *buffer=0;
    return buffer; 
} 

//--------------------------------------------------------
char * convertString(char *text){
//--------------------------------------------------------
// Die Zeichen  fr's Display umwandeln
  char *p;
  char c;
  p=text;
  while ((c=*p)){
    switch(c){
      //case '': *p = 231; break; //Anderes ROM
      case '': *p = 223; break;
      case '': *p = 225; break;
      case '': *p = 239; break;
      case '': *p = 245; break;
      case '': *p = 226; break;
    }    
    p++;
  }
  return text;
}


//--------------------------------------------------------
char * klartextDisplay(char * buffer, U8 idHaupt, U8 idNeben) {
//--------------------------------------------------------
//Haupt- und Nebentext in buffer schreiben
  prog_char *text;
  char c;
  U8 n=0;

  *buffer++ = '@';
  *buffer++ = 'h';  //Zeile 1
  text = (prog_char *)pgm_read_word(pgm_texteHaupt + idHaupt);
  while ((c = pgm_read_byte(text)) != '\0') {
     *buffer++ = c;
     text++;
     n++;
  };
  while (n++ < 14){
    *buffer++ = ' ';
  }
  buffer = showval(buffer, " ",3,g.uptimeM); //Laufzeit in Minuten
  *buffer++ = 'm';
 
  
  *buffer++ = '@';
  *buffer++ = 'H'; //Zeile 2
  
  if (99==idNeben){
    n=0;
    text = (char *)pgm_read_word(pgm_texteSpruch + (g.spruch & 7));
    while ((c = pgm_read_byte(text)) != '\0') {
       *buffer++ = c;
       text++;
       n++;
    };
  }else{//Normaler Nebentext
  
  
    
    *buffer++ = ' ';
    *buffer++ = ' ';

    n=2;
    text = (char *)pgm_read_word(pgm_texteNeben + idNeben);
    while ((c = pgm_read_byte(text)) != '\0') {
       *buffer++ = c;
       text++;
       n++;
    };

    //Sonderanzeigen
    //Ist/Solltemperatur beim Heizen 
    if ((3==idNeben)||(9==idNeben)){
      buffer = showTemp1(buffer, " ",g.kleinhirnRecord.temperatur);
      buffer = showTemp0(buffer, "/",g.heizungsregelung.solltemperatur);
      *buffer++ = ''; 
    }
    //Isttemperatur beim abkhlen
    if (2==idNeben){
      buffer = showTemp1(buffer, " ",g.kleinhirnRecord.temperatur);
      *buffer++ = ''; 
      *buffer++ = 'C';
    }
  }
  //Mit Leerzeichen bis zum Ende auffllen
  while (n++ < 20){
    *buffer++ = ' ';
  }

  *buffer = '\0';
  convertString(txMsg);
  return buffer; 
}

//--------------------------------------------------------
U8 drehschalter(void){
//--------------------------------------------------------
//Umrechnen des 5-Bit Drehschalterwertes vom Kleinhirn in Schalterposition 0..20
/*
Pos   Bits      Wert
0     10000     16
1     10011     19 
2     11010     26
3     11001     25
4     11000     24
5     10101     21
6     01111     15
7     01101     13
8     10001     17
9     10110     22
10    00101      5
11    11100     28
12    00110      6
13    01100     12
14    00100      4
15    01011     11
16    10010     18
17    10111     23
18    11011     27
19    11101     29
20    11110     30

*/
  switch (g.kleinhirnRecord.digitalInputs & 31){
    case 16: return 0;
    case 19: return 1;
    case 26: return 2;
    case 25: return 3;
    case 24: return 4;
    case 21: return 5;
    case 15: return 6;
    case 13: return 7;
    case 17: return 8;
    case 22: return 9;
    case  5: return 10;
    case 28: return 11;
    case  6: return 12;
    case 12: return 13;
    case  4: return 14;
    case 11: return 15;
    case 18: return 16;
    case 23: return 17;
    case 27: return 18;
    case 29: return 19;
    case 30: return 20;
    default: return 0;
  }  
}

//--------------------------------------------------------
void USART_Transmit(char data ){
//--------------------------------------------------------
//Ein Byte auf serieller Schnittstelle ausgeben. Mit Timeout.
unsigned int noTimeout=6000;	
  /* Wait for empty transmit buffer */
	while (
           ( !( UCSR0A & (1<<UDRE0)) )   //Puffer bereit, wenn UDRE0 gesetzt
         && noTimeout
        ){
	  noTimeout--;
  }
	/* Put data into buffer, sends the data */
	UDR0 = data;
}

//--------------------------------------------------------
void sendstring(char *text){
//--------------------------------------------------------
//Einen String auf serieller Schnittstelle ausgeben. 
  while(*text){
    USART_Transmit(*text++);
  }
}



//--------------------------------------------------------
void programmtextDisplay(void) {
//--------------------------------------------------------
//Zur Drehschalterposition gehrenden Text ausgeben
//Wenn die Position gendert wurde, Timer "g.programmNochNichtFestgelegt" zurcksetzen
static U8 drehschalterBisher=99;
  prog_char *text;
  char *buffer;
  char c;
  U8 n=0;
  

  n=drehschalter();
	buffer = txMsg;
  *buffer++ = '@';

  if (drehschalterBisher!=n){
    drehschalterBisher=n;
		g.programmNochNichtFestgelegt=36; //ca.4 Sekunden muss der Drehschalter unbewegt sein
    *buffer++ = 'c';  //Clear + Zeile 1
  }else{
    *buffer++ = 'h';  //Zeile 1
	}
  text = (prog_char *)pgm_read_word(pgm_texteProgramm + n);
  while ((c = pgm_read_byte(text)) != '\0') {
     *buffer++ = c;
     text++;
  };

  *buffer = '\0';
  convertString(txMsg);
  sendstring(txMsg);
}

//--------------------------------------------------------
char * errortext(char * buffer, U8 id) {
//--------------------------------------------------------
//Fehlermeldung in buffer ausgeben
  prog_char *text;
  char c;

  buffer = txMsg;
  *buffer++ = '@';
  *buffer++ = 'c';


  text = (prog_char *)pgm_read_word(pgm_texteError ); //Erste Zeile: "Fehler:"
  while ((c = pgm_read_byte(text)) != '\0') {
     *buffer++ = c;
     text++;
  };
  *buffer++ = '@';
  *buffer++ = 'H'; //gehe in 2. Zeile

  text = (prog_char *)pgm_read_word(pgm_texteError + id); //Zweite Zeile: Fehlermeldung
  while ((c = pgm_read_byte(text)) != '\0') {
     *buffer++ = c;
     text++;
  };
  *buffer = '\0';
  convertString(txMsg);

  return buffer; 
}


//--------------------------------------------------------
char * showstr(char *buffer, const char  * txt){
//--------------------------------------------------------
//Text in buffer kopieren
  while ((*buffer++ = *txt++));
  return buffer-1;
}

//--------------------------------------------------------
char * showval(char * buffer, const char  * txt, int len, int val ){
//--------------------------------------------------------
// txt als Prambel und integer-Zahlenwert val mit len Stellen in den buffer schreiben
// Am Ende ein Leerzeichen anfgen
  char neg; 
  int i; 

    while ((*buffer++ = *txt++));  //Txt kopieren
    buffer--;
    if (len<1) return buffer; 
    if (val < 0){ 
      val=0-val; 
      neg=1; 
    }else{ 
      neg=0; 
    }   
    i=len; 
    do{ 
      buffer[--i] = (val % 10) + '0'; 
      val /= 10; 
    }while (val && (i>neg)); 
    if (val){ 
      for (i=0; i<len; buffer[i++] = '#'); 
      i=0;
    }
    if (i && neg){ 
      buffer[--i] = '-'; 
    } 
    while (i){ 
      buffer[--i] = ' '; 
    } 
    buffer+=len;   
    buffer[0] = ' ';
    buffer[1] = 0;
    return buffer+1; 
} 

//--------------------------------------------------------
I16 aktuellerWasserstand(void){
//--------------------------------------------------------
  return g.kleinhirnRecord.wasserstand - g.waschablauf.anfangswasserstand;
}    

//--------------------------------------------------------
ISR(USART_RX_vect){ //Zeichen von RS232 empfangen
//--------------------------------------------------------
  g.RxBuffer[g.RxBufferWrite++] = UDR0;
  if (RX_BUFFERSIZE == g.RxBufferWrite){
    g.RxBufferWrite=0;
  }
}

//--------------------------------------------------------
ISR(TIMER0_OVF_vect){ //16ms Timer (Zeitbasis)
//--------------------------------------------------------
static U8 tic=7;
  if (0==--tic){
    tic=7;
    g.tic112ms++;
  }
}

//--------------------------------------------------------
ISR(TIMER2_COMPA_vect){ //Triac aus Interrupt
//--------------------------------------------------------
  TROMMELMOTOR_TRIAC_aus;
  TCCR2B = 0;    //Timer aus.
  TCNT2  = 0;    //Reset Timer2
}

//--------------------------------------------------------
ISR(TIMER2_COMPB_vect){ //Triac znden
//--------------------------------------------------------
  TROMMELMOTOR_TRIAC_ein;
}

//--------------------------------------------------------
ISR(TIMER1_CAPT_vect){ //Tacho Interrupt
//--------------------------------------------------------
//Dise Routine wird bis zu 2000 mal pro Sekunde aufgerufen.
//Daher wurden einige Variablen fest Prozessorregistern zugeordnet,
//um die Verarbeitung schneller zu machen.
  I16  p; 
  /* 
    p1=ICR1;
    if (p1 < p0){
      p=65535 - p0 + p1 +1;
    }else{
      p = p1 - p0;
    }
    ^^^^^^^^ das geht bei unsigned int Variablen auch direkt mit p = p1 - p0;
  */
    
  p = ICR1 - p0;
  p0 = ICR1;

  //Messreihe fr eine Umdrehung aufzeichnen (Fr Unwuchtmessung)
  if (g.indexUmlauf){
    g.auUmlauf[--g.indexUmlauf] = p;
  }


  if (g.cInvalid > 1){ //Zwei berlufe ohne Interrupt
    valt=0;
  }else{  
    if (0==g.motor.aufloesung){
      v =(uint16_t)46830 / (p>>2); // p1-p0 gibt 1561 bei 41Hz Tachosignal. 
                                   // 46830/(1561/4) gibt v=120 fr 30 1/min.
    }else{
      v =(uint16_t)46830 / p;      // 46830/1561 gibt v=30 fr 30 1/min.
    }
    d = v - valt;
    valt = v;
    //Tachowerte werden auerhalb der Interrupt-Routine gelesen. 
    //Da 16-Bit Zugriffe nicht atomar sind, erfolgt der
    //Zugriff ber 2 Variable (eine wird hier geschrieben, die andere auerhalb gelesen)
    if (g.cSlot){  
      g.iTacho0 = v;
      g.iTachoDelta0 = d;
      g.cSlot = 0;
    }else{
      g.iTacho1 = v;
      g.iTachoDelta1 = d;
      g.cSlot = 1;
    }
  }
  g.cInvalid=0;
}

//--------------------------------------------------------
ISR(TIMER1_OVF_vect){ //"Kein Tachosignal" Interrupt
//--------------------------------------------------------
  if (g.cInvalid < 16)  g.cInvalid++;

  if (g.cInvalid > 1){ //Zwei berlufe ohne Interrupt: Motor steht!
    if (g.cSlot){
      g.iTacho0 = 0;
  	  g.iTachoDelta0 = 0;
	    g.cSlot = 0;
    }else{
      g.iTacho1 = 0;
	    g.iTachoDelta1 = 0;
	    g.cSlot = 1;
    }
  }
}

//--------------------------------------------------------
ISR(INT0_vect){ //Nulldurchgang (100Hz Interrupt)
//--------------------------------------------------------
  if (
           (0==TCCR2B) //Ignoriere dazwischenfunkende Interrupts
        && g.Motortriacfreigabe
        && (g.motor.cZuendzeit <= 111) //Sptere Zndwinkel werden nicht gebraucht. Da kann man auch abschalten.
      )
  { 
      
      
    /*
       Timer2 wird im Normal-Mode gestartet. 
      OCRA+B lsen Interrupts aus:
      OCR2B: Triaczndung
      OCR2A: Triac lschen, Timer stoppen
    */      
    //Ticker synchronisieren
    GTCCR  = (1<<PSRASY); //clear Timer 2 prescaler
    //TCCR2B = 0;  // Timer ist bereits aus
    //TCNT2  = 0;           //Reset Timer2

    TIFR2 |= ((1<<OCF2A) | (1<<OCF2B) | (1<<TOV2));  //Reset overflow Flags
    //OCR2A = 140; //Bei IRQ: Triac wieder aus, Nulldurchgang wieder scharf.
    OCR2B = g.motor.cZuendzeit; //Triac znden
      
    TCCR2B = (1<<CS22)|(1<<CS21)|(1<<CS20);   //Timer an. Teiler=1024. 16000Hz
                                               // Zhlt in Halbwelle also bis 160
                                               //Das letzte Viertel einer HW wird nie als Zndpunkt gebraucht. 
      
      
/*
        CS22 CS21 CS20 Description:
        0    0    0    No clock source (Timer/Counter stopped).
        0    0    1    No prescaling
        0    1    0    /8    (From prescaler)
        0    1    1    /32   (From prescaler)
        1    0    0    /64   (From prescaler)
        1    0    1    /128  (From prescaler)
        1    1    0    /256  (From prescaler)
        1    1    1    /1024 (From prescaler)
*/
      
  }

  if (g.tic10ms & 1) g.Reglerschritt=0; //Regelung alle 20ms (jede Vollwelle) anwerfen
   
   //100ms Timer
  g.tic10ms++;
  if (10==g.tic10ms){
    g.tic10ms=0;
    g.next100ms=1;
  }
  
}

//--------------------------------------------------------
void USART_Init(void){  //RS232 initialisieren
//--------------------------------------------------------
 
	/* Set baud rate: round(f_osc / (8*baudrate)) - 1  wenn U2X=1*/
	/* Set baud rate: round(f_osc / (16*baudrate)) - 1  wenn U2X=0*/
	UBRR0H = 0;
	UBRR0L = 212; //4800 Baud bei 16.384 MHz, U2X0=0

  UCSR0A=(1<<TXC0); //Clear TXC; U2X0=0

	/* Set frame format:          2stop bit   8data,*/
	UCSR0C = (1<<USBS0)| (1<<UCSZ01) | (1<<UCSZ00);

	// Enable Transmitter and Receiver and RxInterrupts
	UCSR0B = (1<<TXEN0)|(1<<RXEN0)|(1<<RXCIE0);
}


//--------------------------------------------------------
U8 RxDataAvail(void){ //Wieviele Zeichen sind im Puffer
//--------------------------------------------------------
  return (g.RxBufferWrite + RX_BUFFERSIZE - g.RxBufferRead) % RX_BUFFERSIZE;
}

//--------------------------------------------------------
U8 RxDataGetByteFast(void){ //Unsicher! Nur aufrufen, wenn RxDataAvail() >0
//--------------------------------------------------------
U8 data;
  data = g.RxBuffer[g.RxBufferRead++]; 
  if (RX_BUFFERSIZE == g.RxBufferRead){
    g.RxBufferRead = 0;
  }
  return data; 
}

//--------------------------------------------------------
void receiveTelegramm(void){ //RS232-Telegramm empfangen
//--------------------------------------------------------
static U8 status=0;
static U8 *structPtr;
U8 i;

/*  TkleinhirnRecord:
  U8  FF;    Start-
  U8  FE;          Zeichen
  U16 wasserstand;
  I16 temperatur;    in 1/10 Grad Celsius
  U8   a;    
  U8   b;    
  U8   c;    
  U8   d;    
  U8   e;    
  U8   digitalInputs;  Drehschalterstellung
  U8  cr;  
  U8  lf;  

*/

  switch(status){
    case 0: //Warte auf 1. Startzeichen 0xff
      if ( RxDataAvail() ){
        if (0xff == RxDataGetByteFast()){
          status = 1;
        }
      }
    break;
    case 1:  //Warte auf 2. Startzeichen 0xfe
      if ( RxDataAvail() ){
        if (0xfe == RxDataGetByteFast()){
          status = 2;
        }else{
          status = 3;
        }
      }
    break;

    case 2: //Warte, bis Telegramm vollstndig
      if ( RxDataAvail() >= sizeof(TkleinhirnRecord)-2){
        structPtr = (U8*) &g.kleinhirnRxRecord.wasserstand;
        i=sizeof(TkleinhirnRecord)-2;
        while (i--){
          *structPtr++ = RxDataGetByteFast();
        } 
        if (    (13 == g.kleinhirnRxRecord.cr) 
             && (10 == g.kleinhirnRxRecord.lf)) {
          memcpy((U8*)&g.kleinhirnRecord, (U8*)&g.kleinhirnRxRecord, sizeof(TkleinhirnRecord));
          g.kleinhirnSendet=30;
          status = 0;
          if (g.empfangeneTelegramme < 100) g.empfangeneTelegramme++; 
        }else{
          status = 3;
        }
	
      }
    break;

    case 3: // Sync verloren. Warte auf 0x0A (LF).
      if ( RxDataAvail() ){
        if (0x0A == RxDataGetByteFast()){
          status = 0;
        }
      }
      //TODO: Wenn nur Schrott kommt: Fehlerzustand anspringen
    break;

  }//switch
}//receiveTelegramm()

//--------------------------------------------------------
void spsReversieren(void){  //wird alle 500ms einmal aufgerufen
//--------------------------------------------------------
static U8 status=0;
static U8 linksrum=0;
static U8 dauer=0;
static U8 tic=0;
static U8 zyklenzaehler=0;
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  // Statusmaschine "Reversierbetrieb"
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  // Luft, solange g.reversieren.anzahl > 0
  // anzahl gibt Anzahl an Halbzyklen an
  // Begonnen wird mit Pause

  if (tic){  //alle 2 Aufrufe ist eine Sekunde rum
    tic=0;
    dauer++;
  }else tic=1;


  if (255==g.reversieren.anzahl){
    g.reversieren.anzahl = 0;
  }

  if (0==g.reversieren.anzahl) {

    if (status){ //Reversieren abbrechen
      RELAIS_RECHTS_aus;      
      RELAIS_LINKS_aus;      
      RELAIS_SCHNELL_aus;      
      g.motor.solldrehzahl=0; //Motor aus
    }
    status = 0;
  }

  switch(status){
    case 0: //Warte auf Auftrag
        
      g.reversieren.inPause=1;        //Zum Synchronisieren mit Abkhlen
      if (g.reversieren.anzahl){
        TUERVERRIEGELUNG_ein;
        dauer = 0;
//        linksrum = 1; <-besser_ jedesmal andersrum
        status = 1;
      }          
    break;
      
    case 1: //Alles aus. Pause. Nach Pause: Relais Re/Li ein
      RELAIS_RECHTS_aus;      
      RELAIS_LINKS_aus;      
      RELAIS_SCHNELL_aus;      
      g.motor.solldrehzahl=0; //Motor aus
      g.reversieren.inPause=1;        //Zum Synchronisieren mit Abkhlen

      if (dauer >= g.reversieren.pausenzeit){
        if (g.reversieren.wasserstandsanpassung){
          g.reversieren.wasserstandsanpassung = 0; //Einmalig Wasserstand anpassen
          if (aktuellerWasserstand()  < g.waschablauf.wasserstandSoll){
            VENTIL_HAUPTWASCH_ein;
            status = 5; //Wasser nachfllen
            break;
          }
        }
        if (linksrum){
          RELAIS_LINKS_ein;      
          linksrum=0;  
        }else{   
          RELAIS_RECHTS_ein;      
          linksrum=1;
        }
        status++;
      }
    break;

    case 2:   // hochfahren auf Reversierdrehzahl
      g.reversieren.inPause=0;
      dauer=0;
      g.motor.aufloesung=0; //Fr niedrige Geschwindigkeit
      zyklenzaehler++;
      if (
             (g.reversieren.drehzeit > 6) 
          && (g.reversieren.anzahl > 30)
          && (zyklenzaehler>6)
         ){
        g.motor.solldrehzahl=86;  //<-- selten Vrev
        zyklenzaehler=0;
      }else{
        g.motor.solldrehzahl=58;  //<-- oft 
      }
      status++;
    break;

    case 3: //Drehen
      if (dauer >= g.reversieren.drehzeit){
        
        g.motor.solldrehzahl=0;
        dauer=0;
        g.reversieren.anzahl--;
        if (g.reversieren.anzahl){
          status = 1;
        }else{
          RELAIS_RECHTS_aus;      
          RELAIS_LINKS_aus;      
          status = 0;
        }
      }
    break;

   //case4..9: luft automatisch weiter. Magnetventil soll halt nicht nur fr 1/2s an gehen

    case 10: // Wasser nachfllem
      if (aktuellerWasserstand()  > g.waschablauf.wasserstandSoll){
        VENTIL_HAUPTWASCH_aus;
        status = 1;
      }
    break;

    default: 
      if (status++ > 10) status=0;
    break;
 
  } //Switch reversieren.status
}

//--------------------------------------------------------
void spsAbpumpen(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
static U8 status=0;
static U8 dauer=0;
static U16 niedrigsterWasserstand;

  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  // Statusmaschine "Abpumpen bis Wasser weg plus Zusatzlaufzeit"
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  // Wertet g.abpumpen.nachlaufzeit und g.abpumpen.intervallpumpen aus
  //Beim Intervallpumpen wird 7s gepumpt falls Wasserstand>10 und dann fr g.abpumpen.intervallpumpen Sekunden pausiert. 
  //Beim Extrapumpen wird 15s gepumpt. 
  dauer++;

  if (g.abpumpen.extrapumpen){
    g.abpumpen.extrapumpen=0;
    LAUGENPUMPE_ein;  
    dauer=0;
    status=4;
  }
  if (g.abpumpen.nachlaufzeit < 0){ //Reset der Statusmaschine
    g.abpumpen.extrapumpen=0;
    g.abpumpen.intervallpumpen = 0;
    g.abpumpen.nachlaufzeit=0;
    LAUGENPUMPE_aus;
    status=0;
  }

  switch(status){
    case 0:  
               // LAUGENPUMPE_aus; <-Darf nicht, wird auch von spsAbkuehlen benutzt 
      if (g.abpumpen.nachlaufzeit){
         niedrigsterWasserstand = g.kleinhirnRecord.wasserstand;
         dauer=0;
         g.heizungsregelung.solltemperatur = 0;
         status=1;
      }
      break;

    case 1:  
      LAUGENPUMPE_ein;  
      if (g.kleinhirnRecord.wasserstand < niedrigsterWasserstand){
        niedrigsterWasserstand = g.kleinhirnRecord.wasserstand;
        dauer=0;
      }
      if (dauer >= g.abpumpen.nachlaufzeit){
        if (g.abpumpen.intervallpumpen){
          dauer=0;
          status = 2;
        }else{
          g.abpumpen.nachlaufzeit = 0;
          LAUGENPUMPE_aus;
          status = 0;
        }
      }
      break;

    case 2: //intervallpumpen: Pause
      LAUGENPUMPE_aus;  
      if (dauer >= g.abpumpen.intervallpumpen){
        dauer=0;
        status = 3;
      }
      if ((0==g.abpumpen.nachlaufzeit) || (0==g.abpumpen.intervallpumpen)){
        g.abpumpen.intervallpumpen=0;
        g.abpumpen.nachlaufzeit=0;
        status = 0;
      }
      break;

    case 3: //intervallpumpen: Pumpen fr 7s
      if (aktuellerWasserstand() > 9){ //Nur Pumpen, wenn Wasser vorhanden.
        //Beim Schleudern >100 1/min ist auch bel trockener Trommel der 
        //gemessene Wasserstand > 20 (Stark schwankend)
        //Kommt wahrscheinlich durch den Luftzug der Trommel.
        //Beim Schleudern wird also die Pumpe bestimmt laufen.
        LAUGENPUMPE_ein;  
      }
      if (dauer >= 7){
        dauer = 0;
        status = 2;
      }
      break;      

    case 4: //Extrapumpen: Pumpen fr 20s (wird beim Anschleudern benutzt)
      if (dauer >= 20){
        status = 0;
      }
      break;      
  }    
}//spsAbpumpen()



//--------------------------------------------------------
void spsAbkuehlen(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
      //Reversieren mit kurzer Pausenzeit, dabei:
      // 2-7 Mal wiederholen (bis Temperatur unter 30): 
      //   Abpumpen auf 4/5 Wasserstand
      //   Wassereinlauf auf 5/5
      //   30s warten (dabei reversieren)
static U8 statusAbkuehlen=0;
static U16 zielwasserstand=0;

static U8 timeout=0;
static U8 zyklen=0;
U16 w=0;

  if (!g.abkuehlen.freigabe){
    statusAbkuehlen=0;
  }  
  timeout++;
  
  switch(statusAbkuehlen){
     case 0: //Warte auf Freigabe
      if (g.abkuehlen.freigabe){
        g.heizungsregelung.solltemperatur = 0;
        //Reversieren mit kurzer Pausenzeit einschalten
        g.reversieren.pausenzeit = 3;
        g.reversieren.drehzeit = 10;
        g.reversieren.anzahl = 0;  
        zyklen = 0;
        statusAbkuehlen++;
      }  
      break;
    //case1: Warte 10s bis sich Wasser aus der Wsche unten gesammelt hat

    case 10:
      //Abpumpen auf 4/5 Wasserstand. Reversieren dabei aus.
      w = g.waschablauf.wasserstandSoll; 
      zielwasserstand = w - (w / 5);
      LAUGENPUMPE_ein;  
      timeout = 0;
      statusAbkuehlen++;
      break;
    
	  //Mind. 5s pumpen
    
  	case 15:    
      if (aktuellerWasserstand() <= zielwasserstand){
        LAUGENPUMPE_aus;  
        statusAbkuehlen++;
      }else  
      if (timeout > 60){
        g.error = 2; //Pumpenfehler beim Abkhlen
        LAUGENPUMPE_aus;  
        g.abkuehlen.freigabe = 0;
      }
      break;
      
    case 16:    
      VENTIL_HAUPTWASCH_ein;
      timeout = 0;
      g.reversieren.anzahl = 99;  
      statusAbkuehlen++;
      break;
     
	 //Mind. 7s Wassereinlauf
	 
    case 23: 
      if (aktuellerWasserstand() >= g.waschablauf.wasserstandSoll){
        VENTIL_HAUPTWASCH_aus;  
        statusAbkuehlen++;
      }else  
      if (timeout > 60){
        g.abkuehlen.freigabe=0;
        g.error = 3; //Ventilfehler Hauptwasch beim Abkhlen
      }
      break;
      
	 //Umrhren
	 
      //warte 40s  (>=3 Reversierzyklen)

    case 65:  //Aufhren nach 2-7 Zyklen (Temperatur unter 30)
      if (g.reversieren.inPause){ //Reversieren nur in Pause beenden
        g.reversieren.anzahl = 0;  
        zyklen++;    
        
        if (zyklen > 6) g.abkuehlen.freigabe=0; //Aufhrennach 7 Zyklen
        else
        if (g.kleinhirnRecord.temperatur < TEMPERATUR_30) g.abkuehlen.freigabe=0;//Aufhren wenn kalt
		    else statusAbkuehlen = 1; //Nchster Pumpen/Wassereinlauf-Zyklus
      }
      break;

    case 66:
      g.abkuehlen.freigabe=0;
      statusAbkuehlen=0;
      break;
      
    default:
      statusAbkuehlen++;
    break;
  }
}//spsAbkuehlen()

//--------------------------------------------------------
void spsTrocknen(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
/*
   Abpumpen
   Anschleudern mit 300 1/min
   Auflockern
   Schleudern mit Enddrehzahl (g.trocknen.enddrehzahl)
   13s Warten, bis sich Restwasser unten gesammelt hat
*/

static U8 statusTrocknen=0;
  if (!g.trocknen.freigabe){
    statusTrocknen=0;
  }  
  
  g.debugstatus=statusTrocknen;


  switch(statusTrocknen){
    case 0: //Warte auf Freigabe
      if (g.trocknen.freigabe){
        g.reversieren.anzahl = 0;  
        g.abpumpen.nachlaufzeit=-1; //Abpumpen zurcksetzen
        statusTrocknen++;
      }  
      break;
  
    case 2:
      //Abpumpen neu starten
      g.abpumpen.nachlaufzeit=20;
      statusTrocknen++;
      break;

    case 3: //Warte, bis Pumpen fertig
      if (!g.abpumpen.nachlaufzeit){
        statusTrocknen++;
      }
      break;
      
    case 4:
      //Anschleudern 
      g.schleudern.enddrehzahl = 300;
      g.schleudern.schleuderdauer = 1; //nur anschleudern
      g.schleudern.freigabe = 1;
      statusTrocknen++;
      break;
      
    case 5: //Warte bis fertig angeschleudert
     if (!g.schleudern.freigabe){ //Fertig angeschleudert
       g.reversieren.pausenzeit = 3;
       g.reversieren.drehzeit = 4;
       g.reversieren.anzahl = 2;  // auflockern
       statusTrocknen++;
     }
     break;

    case 6: //Warte bis aufgelockert
     if (0==g.reversieren.anzahl){ 
       g.schleudern.enddrehzahl = g.trocknen.enddrehzahl;
#if TEST
       g.schleudern.schleuderdauer = 20; 
#else
       g.schleudern.schleuderdauer = 80; 
#endif
       g.schleudern.freigabe = 1;
       statusTrocknen++;
     }
     break;


    case 7: //Schleudern auf z.B. 600 1/min  (enddrehzahl)
      if (!g.schleudern.freigabe){ //Fertig geschleudert
        statusTrocknen++;
      }
      break;
      
    case 8:
      statusTrocknen++;
      if (g.waschablauf.schnellwaesche) g.trocknen.freigabe = 0;
      break;
	//13s warten, bis Restwasser im Pumpensumpf

	  case 20:
        g.trocknen.freigabe = 0;
        statusTrocknen = 0;
     	break;

    default:
      statusTrocknen++;
      break;
  }   
}//spsTrocknen

//--------------------------------------------------------
void spsHeizung(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
// Aufheizen bis Solltemperatur, dann alle 4 Minuten nachheizen
static U8 warten=0;
static U8 status=0;
static U8 bisher=0;

  switch(status){
     case 0: //Aufheizen falls ntig
      if (!g.heizungsregelung.solltemperatur){
        RELAIS_HEIZUNG_aus;
      }else
      //ca. 1,5 Grad Hysterese  
      if ((g.heizungsregelung.solltemperatur - 10) > g.kleinhirnRecord.temperatur){ //Temp zu niedrig
        g.heizungsregelung.solltemperaturErreicht=0;
        RELAIS_HEIZUNG_ein;
      }else
      if ( (g.heizungsregelung.solltemperatur + 5) < g.kleinhirnRecord.temperatur){//Temp erreicht
        g.heizungsregelung.solltemperaturErreicht=1;
        RELAIS_HEIZUNG_aus;
        bisher = g.heizungsregelung.solltemperatur;
        status=1;
        warten=240; //60*4;
      }
      break;

    case 1: //4 Minuten warten (oder eine Solltemperaturnderung kommt)
      warten--;
      if ((0==warten) || (g.heizungsregelung.solltemperatur != bisher)){
        status=0;
      }
      break;
  }
}//spsHeizung()


//--------------------------------------------------------
void spsBiofilmreinigung(void){//Selbstreinigungsprogramm - wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
/*
  Wassereinlauf auf Niveau NORMAL (recht niedrig)
  Aufheizen auf 85C, maximal 45min. heizen
  30 Min Reversieren (Heizung dabei aus)
  10s kaltes Wasser einsplen (Sonst hat die Brhe noch 70)
  Abpumpen
  
  */
static U8 statusBiofilm=0;  
static U16 dauer=0;

  dauer++;
  if (0==g.biofilm.freigabe){
    statusBiofilm=0;
  }

  switch (statusBiofilm){
    case 0: //Warte auf Freigabe
      if (g.biofilm.freigabe){
        g.reversieren.anzahl=0;
        g.abpumpen.nachlaufzeit=0;
        g.abpumpen.intervallpumpen=0;
        g.heizungsregelung.solltemperatur=0;
        g.motor.solldrehzahl=0;
        g.schleudern.freigabe=0;
        g.trocknen.freigabe=0;
        g.abkuehlen.freigabe=0;
        g.reversieren.wasserstandsanpassung = 0;
        statusBiofilm++;
      }
      break;

    case 1: //Wassereinlauf starten
      g.waschablauf.wasserstandSoll = WASSERSTAND_NORMAL; //NORMAL;
      VENTIL_HAUPTWASCH_ein; 
      dauer=0;
      NT_Wassereinlauf;
      statusBiofilm++;
      break;
      
    case 2:   
      // Wasserstand sollte sich sptestens nach 4-5s ndern.
      if (dauer > 6){
        if ( aktuellerWasserstand() < 50){
           VENTIL_HAUPTWASCH_aus;
            /*
               Entweder Wasserhahn zu oder Druckdosenschlauch defekt oder Magnetventil defekt
            */
           g.error = 1; //Kein Wasser
           statusBiofilm=250;  //Fehler 
        }else statusBiofilm++;
      }
      break;

    case 3: //Wassereinlauf ber Hauptwsche
      VENTIL_HAUPTWASCH_ein;
      if ( aktuellerWasserstand() > g.waschablauf.wasserstandSoll){
        VENTIL_HAUPTWASCH_aus;

        statusBiofilm++;
      }
      if (dauer > 60*4){
        g.error = 4; //Wasser ber Hauptwsche kommt zu langsam
        statusBiofilm=250;  //Fehler 
      }
      break;
  
    case 4:
      NT_Aufheizen;
      g.reversieren.pausenzeit = 25;  //mittlere Pausenzeit beim Splen
      g.reversieren.wasserstandsanpassung = 0;
      g.reversieren.drehzeit = 8;
      g.reversieren.anzahl=99;

      g.heizungsregelung.solltemperatur=TEMPERATUR_85;
      if (g.heizungsregelung.solltemperaturErreicht
         || (g.uptimeM > 45)){//Wenn's die Heizung nicht packt, irgendwann aufgeben
        dauer=0;
        statusBiofilm++;
      }
      break;
      
    case 5:
      NT_Warmwaschen;
      g.heizungsregelung.solltemperatur=0;
      if (dauer > 60*30){ //dann noch 30 Minuten nachwaschen
        g.reversieren.pausenzeit = 2;  //kurze Pausenzeit 
        g.reversieren.drehzeit = 10;
        g.reversieren.anzahl=2;
        VENTIL_HAUPTWASCH_ein;
        statusBiofilm++;
      }
      break;

      //20s lang kaltes Wasser zugeben zum runterkhlen


    case 25: //Raus mit der Brhe
      VENTIL_HAUPTWASCH_aus;
      g.reversieren.anzahl=0;
      g.heizungsregelung.solltemperatur=0;
      g.reversieren.anzahl = 0;  
      NT_Pumpen;
      g.waschablauf.anfangswasserstand = 0x2c00; //Deutlich unter dem Messwert bei leerer Trommel
      g.abpumpen.nachlaufzeit=10;
      statusBiofilm++;
      break;

    case 26:
      if (!g.abpumpen.nachlaufzeit){
        g.biofilm.freigabe=0;
      }
      break;
    
     
    case 250: //Fehler
     //Fehlerbehandlung am Ende von MAIN
      break;

    default:
      statusBiofilm++;
      break;
      
  }//switch  

}//spsBiofilmreinigung
//--------------------------------------------------------
void spsSekundentakt(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
  spsWaschablauf();
  spsSpuelgang();
  spsWeichspuelgang();
  spsTrocknen();
  spsAbpumpen();
  spsHeizung();  
  spsAbkuehlen();
  spsBiofilmreinigung();
}

//--------------------------------------------------------
void spsMotor(void){  //wird alle 20ms aufgerufen
//--------------------------------------------------------
static I16 esum=0;
static I16 e, y;
static U8 z;
static I16 tp=0;
static U8 statusMotor;
I16 tacho, delta;
I16 w=0;
// PID-Regler:
      //Kp = 20;
      //Ki = 6; 
      //Kd = 0; 
  /*
      e=Abweichung
      w=Sollwert
      x=Istwert
      y=Ausgabe Stellwert
      Ta=Abtastzeit
      Kp=Proportionalanteil
      Ki=Integralanteil
      Kd=Differentialanteil (unbenutzt)

      e = w-x;  //Reglerabweichung
      esum+=e;  //I-Anteil
      y = Kp*e + Ki*Ta*esum + Kd/Ta*(e-ealt);
      ealt=e;

  */
  // Die 16-Bit Tachowerte werden im Interrupt verndert. 
  // Daher erfolgt der Zugriff ber 2 Variable (eine wird im Interrupt geschrieben, die andere hier gelesen)
  if (g.cSlot){ 
    tacho = g.iTacho1;
    delta = g.iTachoDelta1;
  }else{
    tacho = g.iTacho0;
    delta = g.iTachoDelta0;
  }
  g.motor.istdrehzahl = tacho;

  switch (statusMotor){
    case 0: //Aus
      esum=0;  //I-Regler lschen
      tp=0;
      w=0; //Regler soll von 0 an loslaufen
      g.motor.cZuendzeit=120;
      g.Motortriacfreigabe=0; //Regler ausschalten
      if (g.motor.solldrehzahl){
        g.Motortriacfreigabe=1; //Regler einschalten
        statusMotor++;
      }
      break;

    case 1: //Anfahren
      if (g.motor.aufloesung){
        w = 20;
      }else{
        w = 80; 
      }
      if (tacho > 3){
        statusMotor++;
      }
      break;

    case 2: //Drehen
      if (g.motor.aufloesung){
        w = g.motor.solldrehzahl;
      }else{
        w = g.motor.solldrehzahl<<2; //aufloesung=0, also 120 fr 30 1/min
      }
      if (0==g.motor.solldrehzahl){
        statusMotor=0;
      }
      break;

    default:
      statusMotor=0;
      break;
  }


  //PI-Regler
  e = w - tacho;  //Reglerabweichung

  esum += e;  //I-Anteil
  if (esum > 1200) esum=1200;
  if (esum < -200) esum=-200;

  y = (6*e  //(24 * e /4   //KP=20  //Jetzt:KP=24
     + 6 * (esum /10) //KI=6
      )
  /30 ;


  //Begrenzen
  if (y>110) y=110;
  if (y<0) y=0;

  delta=y-tp; //Ruckbegrenzung
  if (e < 30){ //Dauerlaufphase
    if (delta>6) delta=6;
    if (delta<-2) delta=-2;
  }else{ //Hochlaufphase
    if (delta>2) delta=2;
    if (delta<-3) delta=-3;
  }
  tp+=delta;


  //Phasenanschnitt
  z = 112 - tp; 

  //Abschalten bei Sollwert=0
  if (g.motor.solldrehzahl < 10){
    z=160;
    esum=0;
    tp=0;
  }

  if (z < 20) z=20; //
  g.motor.cZuendzeit = z; //Whrend Unwuchtmessung einfach weiterregeln. Der Regler ist eh zu lahm!
}//spsMotor


//--------------------------------------------------------
void berechneUnwucht(void){ 
//--------------------------------------------------------
/*
   Es werden die Zeitabstnde der Tachopulse fr eine Umdrehung aufgezeichnet.
   Das gibt so etwas wie eine verbeulte Sinusschwingung, deren Amplitude 
   der Unwucht entspricht. Die Amplitude wird bestimmt und ausgewertet.
*/

static U8 stepUnwucht=0; //Status in Unwuchtmessung-Ablauf
static I16 min, max;
static U8 iu; //Index in Unwuchtmessung
static U16 *pUmlauf; 
static I16 mittel;
static I32 sum, streuung;
static I16 delta;

  //Berechnung wird nur beim Schleudern gebraucht
  if (!g.schleudern.freigabe) return;

  //zyklisch die Unwucht messen
  switch(stepUnwucht){
    case 0:  
      g.indexUmlauf = 83; //Messung starten
      stepUnwucht++;
      break; 

    case 1: //Warte, bis Messung fertig
      if (!g.indexUmlauf){
        //pUmlauf = g.auUmlauf; 
        pUmlauf = (uint16_t *)&g.auUmlauf[0]; //<----------Ohne das Casten meckert der Compiler, warum auch immer...
        min = max = *pUmlauf;
        sum = 0;
        iu = 82;
        stepUnwucht++;
      }
      break;

    case 2:  //Mittelwert, Min und Max berechnen
      pUmlauf++;
      if (iu--){
        if (*pUmlauf < min) min = *pUmlauf;
        if (*pUmlauf > max) max = *pUmlauf;
        sum += *pUmlauf;
      }else{
        mittel=sum / 82;
        g.schleudern.unwucht = max-min;
        sum=0;
        iu=83;
        pUmlauf = (uint16_t *) &g.auUmlauf[0];
        stepUnwucht++;
      }
      break; 

    case 3:  //Streuung und mittlere Abweichung berechnen
      if (iu--){
        delta = (mittel - *pUmlauf);
        if (delta >= 0){
          sum += delta;
        }else{ 
          sum -= delta;
        }  
        streuung += delta * delta;
        pUmlauf++;
      }else{
//          sum /=82;
        sum /=10;
        streuung /=82;
        g.schleudern.streuung = streuung;
        stepUnwucht++;
      }
      break; 


    default:
      stepUnwucht=0;
      break;
  }//switch stepUnwucht
}//berechneUnwucht()

//--------------------------------------------------------
void spsSchleudern(void){  //wird alle 100ms einmal aufgerufen
//--------------------------------------------------------
//Starten mit g.schleudern.freigabe=1
//Parameter: 
//  g.schleudern.schleuderdauer
//  g.schleudern.enddrehzahl
//static U8 ablaufSchleudern;
static U16 dauer=0;
static U8 tic=0;
static U8 versuch;
static U8 tolerierteUnwucht;
static U16 tolerierteStreuung;

  tic++;
  if (tic>9){
    tic=0;
    dauer++;  //Sekundentakt
  }

  // ---------------------------------------------------------------

  // Ablaufsteuerung des Schleudervorgangs

  if ((0==tic) || (5==tic)){  //alle 500ms
    switch(g.schleudern.ablaufSchleudern){
      case 0:
        if (g.schleudern.freigabe){ //Freigabe erteilt
          versuch=0;
          g.schleudern.ablaufSchleudern=1;

          TUERVERRIEGELUNG_ein;

          if (g.schleudern.enddrehzahl <= 350){
            tolerierteUnwucht=70;
            tolerierteStreuung= 250;
          }else
          if (g.schleudern.enddrehzahl <= 700){
            tolerierteUnwucht=30;
            tolerierteStreuung= 210;
          }else
          if (g.schleudern.enddrehzahl <= 900){
            tolerierteUnwucht=21;
            tolerierteStreuung= 200;
          }else{
            tolerierteUnwucht=19;
            tolerierteStreuung= 190;
          }
        }
      break;

      case 1:
        g.motor.solldrehzahl=0;
        RELAIS_LINKS_aus;
        RELAIS_RECHTS_ein;
        RELAIS_SCHNELL_ein;

        g.motor.aufloesung=0; //Fr niedrige Geschwindigkeit
        g.abpumpen.nachlaufzeit=10;
        g.abpumpen.intervallpumpen = 15;
        g.schleudern.ablaufSchleudern++;
        break;

      case 2: //nach 100ms hat Relais sicher angezogen
        g.motor.solldrehzahl=45; 
        g.schleudern.ablaufSchleudern++;
        break;


   // Mit Rampe hochfahren. 

      case 5: //auf ca. 60 1/min gehen (Grenzdrehzahl, bei der Wsche grade am Umfang klebt)
        g.motor.solldrehzahl += 2;
        if (g.motor.solldrehzahl >= 60){
          g.schleudern.ablaufSchleudern=6;
        }
        break;

      case 20: //Anlegephase: mit Rampe langsam hochdrehen
        g.motor.solldrehzahl ++;
        if (g.motor.solldrehzahl > 105){
          dauer=0;
          g.schleudern.ablaufSchleudern++;
        }
        break;

      case 22:// Unwucht messen. Wenn OK auf 300 1/min
       if (g.schleudern.unwucht <= tolerierteUnwucht){
         g.abpumpen.extrapumpen=1;
         g.motor.solldrehzahl = 300;
         g.motor.aufloesung=1; //Fr hohe Geschwindigkeit
         g.schleudern.ablaufSchleudern=30; //Schleudern
         dauer=0;
       }

       if (dauer > 8){ //Timeout: Nochmal runtertouren
         g.motor.solldrehzahl=0;
         g.schleudern.ablaufSchleudern=24;
         dauer=0;
       }
       break;

     //Anderer Algorithmus: 
     //Bei 60 1/min warten, bis Unwucht OK, dann auf 100 1/min
     //Wenn auf 100 OK, hochtouren

     case 25:// Nochmal runter und dann langsam erhhen; Unwucht messen. Wenn OK auf 100
       g.motor.solldrehzahl = 60 + (dauer/3)*2;
       if (g.schleudern.streuung <= tolerierteStreuung){
         g.motor.solldrehzahl = 100;
         g.motor.aufloesung=1; //Fr hohe Geschwindigkeit
         g.schleudern.ablaufSchleudern++;
         dauer=0;
       }

       if (dauer > 50){//Timeout: Wsche umschichten
         dauer=0;
         g.motor.solldrehzahl = 0;
         g.schleudern.ablaufSchleudern=90; //Nochmal reversieren
       }
       break;

     case 27:// auf 100 laufen lassen. Wenn Unwucht OK hochtouren
       if (g.schleudern.streuung <= 60) {
         dauer=0;
         g.abpumpen.extrapumpen=1;
         g.motor.solldrehzahl=300;
         g.schleudern.ablaufSchleudern=30; 
       }
       if (dauer > 10){ //Timeout. Wsche umschichten
         dauer=0;
         g.schleudern.ablaufSchleudern=90;
       }
       break;

     case 30: //alle 12s um 100 erhhen, bis Enddrehzahl erreicht
       //Pumpe rappelt gegen das Gehuse wenn sie beim Schleudern aus ist.
       //Intervalpumpen daher abgeschaltet.
       //g.abpumpen.intervallpumpen = 10 + g.motor.solldrehzahl / 100;
       g.abpumpen.intervallpumpen = 0;
       g.abpumpen.nachlaufzeit=99;
       if ((dauer > 11) || (dauer > g.schleudern.schleuderdauer)){ //Abbruch, wenn nur anschleudern gefordert
         dauer=0;
         g.motor.solldrehzahl+=100;
         if (g.motor.solldrehzahl >= g.schleudern.enddrehzahl){
           g.schleudern.ablaufSchleudern=50; 
         }
       }
       break;
      
     case 50://   nach Schleuderzeit runtertouren
        if (dauer > g.schleudern.schleuderdauer){
          g.motor.solldrehzahl = 0;
          g.schleudern.ablaufSchleudern++;
        }
        break; 

     case 51://   Trommel steht. Relais ausschalten. Fertig!
       if (g.iTacho0 < 30){
         RELAIS_RECHTS_aus;
         RELAIS_SCHNELL_aus;
         g.abpumpen.nachlaufzeit=0;
         g.abpumpen.intervallpumpen=0;
         g.schleudern.freigabe=0;
         g.schleudern.ablaufSchleudern=0; 
       }
       break;

     // Reversieren zum umschichten
     case 90: //Runtertouren 
       g.motor.solldrehzahl = 0;
       g.schleudern.ablaufSchleudern++;
       break;

     case 94: //Warte, bis Trommel steht
       RELAIS_SCHNELL_aus;
       RELAIS_RECHTS_aus;
       if (0==g.iTacho0){
         g.reversieren.pausenzeit =2;
         g.reversieren.drehzeit = 5;
         g.reversieren.anzahl=3;
         g.schleudern.ablaufSchleudern++;
       }
       break;

     case 97:
       if (0==g.reversieren.anzahl){
         dauer=0;
         versuch++;
         tolerierteUnwucht+=10;
         tolerierteStreuung+=10;

         if (versuch < 2){

           //Weil's mit dem Auswuchten nicht klappt: Schleuderdrehzahl begrenzen 
           if (g.schleudern.enddrehzahl >900){
             g.schleudern.enddrehzahl = 900;
           }

           g.schleudern.ablaufSchleudern = 1; //Nochmal versuchen
         }else{
           RELAIS_RECHTS_aus;      
           RELAIS_LINKS_aus;      
           RELAIS_SCHNELL_aus;      
           g.schleudern.freigabe=0;
           g.schleudern.ablaufSchleudern = 0;
         }
       }
       break;


      default:
        g.schleudern.ablaufSchleudern++; //Fehlende Ablaufschritte werden alle 100ms hochgezhlt
        break;

    }//switch ablaufSchleudern
  }
}//spsSchleudern()




//--------------------------------------------------------
void spsSpuelgang(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
/*
  Wassereinlauf ber Hauptsplkammer auf Niveau Splen
  Reversieren, nach 1 Min. und 2 Min. ggf. Wasser nachfllen
  10 Min Reversieren
  Trocknen
  
  */
static U8 statusSpuelgang=0;  
static U8 dauer=0;
static U16 wasserstandSoll;
static U8 sekunden=0;
static U8 minuten=0;

  dauer++;
  sekunden++;
  if (sekunden > 59){
    minuten++;
    sekunden = 0;
  }
  if (0==g.spuelgang.freigabe){
    statusSpuelgang=0;
  }

  switch (statusSpuelgang){
    case 0: //Warte auf Freigabe
      if (g.spuelgang.freigabe){
        g.reversieren.anzahl=0;
        g.abpumpen.nachlaufzeit=0;
        g.abpumpen.intervallpumpen=0;
        g.heizungsregelung.solltemperatur=0;
        g.motor.solldrehzahl=0;
        g.schleudern.freigabe=0;
        g.trocknen.freigabe=0;
        g.abkuehlen.freigabe=0;
        g.reversieren.wasserstandsanpassung = 0;
        minuten=0;
        sekunden=0;
        statusSpuelgang++;
      }
      break;

    case 1: //Wassereinlauf starten
      switch  (g.waschablauf.Wasserniveau){
      case 1:
        wasserstandSoll = WASSERSTAND_NORMAL; //NORMAL;
        break;
      case 2:
        wasserstandSoll = WASSERSTAND_SPUELEN; //ERHOEHT;
        break;
      case 3:
        wasserstandSoll = WASSERSTAND_WOLLE;   //Wolle
        break;
      case 4:
        wasserstandSoll = WASSERSTAND_SPUELEN_HOCH; //wie Wolle
        break;

		
      default:
        wasserstandSoll = WASSERSTAND_SPUELEN;
        break;
      }
      VENTIL_HAUPTWASCH_ein; 
      dauer=0;
      NT_Wassereinlauf;
      statusSpuelgang++;
      break;
      
    case 2:   
      // Wasserstand sollte sich sptestens nach 4-5s ndern.
      if (dauer > 6){
        if ( aktuellerWasserstand() < 50){
           VENTIL_HAUPTWASCH_aus;
            /*
               Entweder Wasserhahn zu oder Druckdosenschlauch defekt oder Magnetventil defekt
            */
           g.error = 1; //Kein Wasser
           statusSpuelgang=250;  //Fehler 
        }else statusSpuelgang++;
      }
      break;

    case 3: //Wassereinlauf ber Hauptwsche
      VENTIL_HAUPTWASCH_ein;
      if ( aktuellerWasserstand() > wasserstandSoll){
        VENTIL_HAUPTWASCH_aus;

        g.reversieren.pausenzeit = 4;  //mittlere Pausenzeit beim Splen
        g.reversieren.drehzeit = 10;

        g.reversieren.anzahl=4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 0;
        statusSpuelgang++;
      }
      if (dauer > 60*4){
        g.error = 4; //Wasser ber Hauptwsche kommt zu langsam
        statusSpuelgang=250;  //Fehler 
      }
      break;
  
    case 4:
      NT_Walken;
      if (0==g.reversieren.anzahl){ //nach ca. 1 Minute nochmal Wasserstand prfen
        g.reversieren.anzahl = 4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        statusSpuelgang++;
      }
      break;
      
    case 5:
      if (0==g.reversieren.anzahl){ //nach ca. 2 Minuten nochmal Wasserstand prfen
        g.reversieren.anzahl = 99;  
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        minuten=0;
        sekunden=0;
        statusSpuelgang++;
      }
      break;

    case 6: //12 Min. Reversieren
#if TEST
      if ((minuten >0) && g.reversieren.inPause){ //Reversieren nur in Pause beenden
#else
      if ((minuten >= g.spuelgang.spueldauer) && g.reversieren.inPause){  
#endif
        g.reversieren.anzahl = 0;  
        g.trocknen.freigabe=1;

        if (1==g.waschablauf.spuelgaenge){
          HT_Schleudern;
          NT_Leer;
        }else NT_Trocknen;

        statusSpuelgang++;
      }
      break;
    
    case 7: //Warten. bis Trockenschleudern fertig
      if (0==g.trocknen.freigabe){
        g.spuelgang.freigabe = 0; //Bin fertig mit Splen
        statusSpuelgang = 0;
        NT_Leer;
      }
      break;
     
    case 250: //Fehler
#if 0  //Fehlerbehandlung jetzt am Ende von MAIN

      VENTIL_HAUPTWASCH_aus;
      VENTIL_VORWASCH_aus;
      VENTIL_WEICHSPUEL_aus;
#endif
      break;

    default:
      statusSpuelgang++;
      break;
      
  }//switch  
}//spsSpuelgang

   

//--------------------------------------------------------
void spsWeichspuelgang(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
/*
  Wassereinlauf ber Weichsplkammer auf Niveau Splen
  Reversieren, nach 1 Min. und 2 Min. ggf. Wasser nachfllen
  10 Min Reversieren
  Trocknen
  
  */
static U8 statusWeichspuelgang=0;  
static U8 dauer=0;
static U16 wasserstandSoll;
static U8 sekunden=0;
static U8 minuten=0;

  dauer++;
  sekunden++;
  if (sekunden > 59){
    minuten++;
    sekunden = 0;
  }
  if (0==g.weichspuelgang.freigabe){
    statusWeichspuelgang=0;
  }

  switch (statusWeichspuelgang){
    case 0: //Warte auf Freigabe
      if (g.weichspuelgang.freigabe){
        g.reversieren.anzahl=0;
        g.abpumpen.nachlaufzeit=0;
        g.abpumpen.intervallpumpen=0;
        g.heizungsregelung.solltemperatur=0;
        g.motor.solldrehzahl=0;
        g.schleudern.freigabe=0;
        g.trocknen.freigabe=0;
        g.abkuehlen.freigabe=0;
        g.reversieren.wasserstandsanpassung = 0;
        minuten=0;
        sekunden=0;
        statusWeichspuelgang++;
      }
      break;

    case 1: //Wassereinlauf starten
      switch  (g.waschablauf.Wasserniveau){
        case 1:
          wasserstandSoll = WASSERSTAND_NORMAL; //NORMAL;
          break;
        case 2:
          wasserstandSoll = WASSERSTAND_SPUELEN; //ERHOEHT;
          break;
        case 3:
          wasserstandSoll = WASSERSTAND_WOLLE;   //Wolle
          break;
        case 4:
          wasserstandSoll = WASSERSTAND_SPUELEN_HOCH; //wie Wolle
          break;

      
        default:
          wasserstandSoll = WASSERSTAND_SPUELEN;
          break;
      }
      VENTIL_HAUPTWASCH_ein; //Pumpensumpf nicht mit Weichspler fluten
      dauer=0;
      NT_Wassereinlauf;
      statusWeichspuelgang++;
      break;
      
    case 2:   
      // Wasserstand sollte sich sptestens nach 4-5s ndern.
      if (dauer > 6){
        VENTIL_HAUPTWASCH_aus;
        if ( aktuellerWasserstand() < 50){
            /*
               Entweder Wasserhahn zu oder Druckdosenschlauch defekt oder Magnetventil defekt
            */
           g.error = 1; //Kein Wasser
           statusWeichspuelgang=250;  //Fehler 
        }else statusWeichspuelgang++;
      }
      break;

    case 3: //Wassereinlauf ber Weichspl
      VENTIL_WEICHSPUEL_ein;
      if ( aktuellerWasserstand() > wasserstandSoll){
        VENTIL_WEICHSPUEL_aus;

        g.reversieren.pausenzeit = 4;  //mittlere Pausenzeit beim Splen
        g.reversieren.drehzeit = 10;

        g.reversieren.anzahl=4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 0;
        statusWeichspuelgang++;
      }
      if (dauer > 60*4){
        g.error = 4; //Wasser ber Hauptwsche kommt zu langsam
        statusWeichspuelgang=250;  //Fehler 
      }
      break;
  
    case 4:
      NT_Walken;
      if (0==g.reversieren.anzahl){ //nach ca. 1 Minute nochmal Wasserstand prfen
        g.reversieren.anzahl = 4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        statusWeichspuelgang++;
      }
      break;
      
    case 5:
      if (0==g.reversieren.anzahl){ //nach ca. 2 Minuten nochmal Wasserstand prfen
        g.reversieren.anzahl = 99;  
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        minuten=0;
        sekunden=0;
        statusWeichspuelgang++;
      }
      break;

    case 6: //12 Min. Reversieren
#if TEST
      if ((minuten >0) && g.reversieren.inPause){ //Reversieren nur in Pause beenden
#else
      if ((minuten >= g.weichspuelgang.spueldauer) && g.reversieren.inPause){  
//      if ((minuten >= 2) && g.reversieren.inPause){ //Reversieren nur in Pause beenden
#endif
        g.reversieren.anzahl = 0;  
        g.trocknen.freigabe=1;

        HT_Schleudern;
        NT_Leer;
        statusWeichspuelgang++;
      }
      break;
    
    case 7: //Warten. bis Trockenschleudern fertig
      if (0==g.trocknen.freigabe){
        g.weichspuelgang.freigabe = 0; //Bin fertig mit Splen
        statusWeichspuelgang = 0;
        NT_Leer;
      }
      break;

    case 250: //Fehler
#if 0  //Fehlerbehandlung jetzt am Ende von MAIN
      VENTIL_HAUPTWASCH_aus;
      VENTIL_VORWASCH_aus;
      VENTIL_WEICHSPUEL_aus;
#endif
      break;     
    default:
      statusWeichspuelgang++;
      break;
      
  }//switch(statusWeichspuelgang) 
}//spsWeichspuelgang()

//--------------------------------------------------------
void spsWaschablauf(void){  //wird alle 1000ms einmal aufgerufen
//--------------------------------------------------------
static U8 status=0;
static U8 dauer=0;    //zum messen relativer Zeitablufe. Wird intern mehrfach auf 0 gesetzt.
static U8 sekunden=0;
static U8 minuten=0;

  dauer++;
  sekunden++;
  if (sekunden > 59){
    minuten++;
    sekunden = 0;
  }

  klartextDisplay(txMsg, g.haupttextIndex,g.nebentextIndex);
  g.pSendChar = txMsg;

 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // Statusmaschine Waschablauf
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  switch (status){
    case 0: //erstmal alles aus

       TUERVERRIEGELUNG_aus;
       g.haupttextIndex=0;
       g.nebentextIndex=0;

       g.reversieren.anzahl=0;
       g.abpumpen.nachlaufzeit=0;
       g.abpumpen.intervallpumpen=0;
       g.heizungsregelung.solltemperatur=0;
       g.motor.solldrehzahl=0;
       g.schleudern.freigabe=0;
       g.trocknen.freigabe=0;
       g.abkuehlen.freigabe=0;
       g.waschablauf.fertig=0;

       //Default-Werte
       g.spuelgang.spueldauer=12;
       g.weichspuelgang.spueldauer=12;


       VENTIL_VORWASCH_aus;
       VENTIL_HAUPTWASCH_aus;
       VENTIL_WEICHSPUEL_aus;
       LAUGENPUMPE_aus;
       status++;
       break;

    case 1: //Vorbereitung:  Restwasser (Kondenswasser) abpumpen
      NT_Pumpen;
      g.abpumpen.nachlaufzeit=8;
      minuten=0;
      sekunden=0;
      g.reversieren.wasserstandsanpassung = 0;
      status++;
    break;

    case 2: //Warte, bis Pumpen fertig, dann Tr verriegeln.
      if (!g.abpumpen.nachlaufzeit  && (0==g.programmNochNichtFestgelegt)){
        TUERVERRIEGELUNG_ein;
        NT_verriegeln;
        g.spruch = TCNT1 & 7; //[0..7] recht zuflliger Wert: Zhlerstand vom 64KHz Timer
        status++;
      }
      break;

    case 3: //gewhltes Programm
      switch(drehschalter()){
        case 0: //Abpumpen, Tr auf
          status=70;
          break;

        case 1: //Buntwsche 95C
          g.waschablauf.waschtemperatur = TEMPERATUR_85;
          g.waschablauf.endschleuderdrehzahl = 1200;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;

        case 2: //Buntwsche Energiesparen   -  Schnellwsche 40C
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          g.waschablauf.schnellwaesche=1;
          g.spuelgang.spueldauer=8;
          g.weichspuelgang.spueldauer=7;
          status=4;
          break;
        case 3: //Buntwsche 60C
          g.waschablauf.waschtemperatur = TEMPERATUR_60;
          g.waschablauf.endschleuderdrehzahl = 1200;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          g.waschablauf.schnellwaesche=1;
          status=4;
          break;
        case 4: //Buntwsche 50C 
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 1200;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 5: //Buntwsche 40C
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 700;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;
          status=4;
          break;
        case 6: //Buntwsche 30C
          g.waschablauf.waschtemperatur = TEMPERATUR_30;
          g.waschablauf.endschleuderdrehzahl = 700;
          g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          g.waschablauf.schnellwaesche=1;
          status=4;
          break;
        case 7: //Pflegeleicht 60C
          g.waschablauf.waschtemperatur = TEMPERATUR_60;
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 8: //Pflegeleicht 50C
          g.waschablauf.waschtemperatur = TEMPERATUR_50;
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 9: //Pflegeleicht 40C                     <<<<-----------Meistbenutzt
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
	      case 10: //Pflegeleicht 30C
          g.waschablauf.waschtemperatur = TEMPERATUR_30;
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 11: //Feinwsche 40C
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 600;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 12: //Feinwsche 30C
          g.waschablauf.waschtemperatur = TEMPERATUR_40;
          g.waschablauf.endschleuderdrehzahl = 600;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 13: //Wolle 40C    - Biofilm-Reinigung (85 ohne Wsche und Waschpulver)
          g.biofilm.freigabe=1;
          status=100;
          break;
        case 14: //Wolle 30C
          g.waschablauf.waschtemperatur = TEMPERATUR_30;
          g.waschablauf.endschleuderdrehzahl = 600;
          g.waschablauf.Wasserniveau=2;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 15: //Wolle kaltC 
          g.waschablauf.waschtemperatur = TEMPERATUR_20;
          g.waschablauf.endschleuderdrehzahl = 600;
          g.waschablauf.Wasserniveau=2;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=3;     //Normal 3, bei Schnellwaesche 2
          status=4;
          break;
        case 16: //Feinsplen   -Nochmal Splen und langsam Schleudern
          g.waschablauf.endschleuderdrehzahl = 600;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=1;    
          status=80;
          break;
        case 17: //Strken     -Nochmal Splen und Schleudern
          g.waschablauf.endschleuderdrehzahl = 900;
          g.waschablauf.Wasserniveau=1;    //0=normal 1=hoch 2=Wolle
          g.waschablauf.spuelgaenge=1; 
          status=80;
          break;
        case 18: //Pumpen
          status=70;
          break;
        case 19: //Schleudern  -Nochmal Schleudern
          g.trocknen.enddrehzahl = 1200;
          status=72;
          break;
        case 20: //Schonschleudern   -Nochmal langsam Schleudern
          g.trocknen.enddrehzahl = 600;
          status=72;
          break;

	    }//switch(drehschalter())
      break;	


    //Etwas warten, bis Wassersensor eingeschwungen und Werte bermittelt
      
    case 5: //Wassereinlauf starten
      HT_Hauptwaesche;
      g.waschablauf.anfangswasserstand = g.kleinhirnRecord.wasserstand;
      dauer=0;
      switch  (g.waschablauf.Wasserniveau){
        case 1:
          g.waschablauf.wasserstandSoll = WASSERSTAND_NORMAL;
          break;
        case 2:
          g.waschablauf.wasserstandSoll = WASSERSTAND_ERHOEHT;
          break;
        case 3:
          g.waschablauf.wasserstandSoll = WASSERSTAND_WOLLE;
          break;
        default:
          g.waschablauf.wasserstandSoll = WASSERSTAND_NORMAL;
          break;
      }
      NT_Wassereinlauf;
      VENTIL_VORWASCH_ein; //Wasser 20s ber Vorwasch einlaufen lassen, damit Waschmittel
                           //nicht im Pumpensumpf landet
      status++;
      break;
      
    case 6: // Wasserstand sollte sich sptestens nach 4-5s ndern.
      if (dauer > 7){
        if ( aktuellerWasserstand() < 50){
           VENTIL_VORWASCH_aus;
            /*
               Entweder Wasserhahn zu oder Druckdosenschlauch defekt oder Magnetventil defekt
            */
           g.error = 1; //Kein Wasser
           status=250;  //Fehler 
        }else status++;
      }
      break;

    case 7://Wassereinlauf ber Vorwsche (ohne Splmittel)
      if (  aktuellerWasserstand() > WASSERSTAND_1){
        VENTIL_VORWASCH_aus;
        g.reversieren.pausenzeit = 10;
        g.reversieren.drehzeit = 8;
        g.reversieren.anzahl=99;
        status++;
        dauer=0;
        g.waschablauf.frischwassertemperatur = g.kleinhirnRecord.temperatur;
      }
      if (dauer > 40){
        g.error = 5; //Wasser ber Vorwsche kommt zu langsam
        status=250;  //Fehler 
      }
      break;

    case 9: //Wassereinlauf ber Hauptwsche (mit Splmittel)
      VENTIL_HAUPTWASCH_ein;
      if ( aktuellerWasserstand() > g.waschablauf.wasserstandSoll){
        VENTIL_HAUPTWASCH_aus;
        g.reversieren.anzahl=4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 0;
        status++;
      }
      if (dauer > 60*4){
        g.error = 4; //Wasser ber Hauptwsche kommt zu langsam
        VENTIL_HAUPTWASCH_aus;
        status=250;  //Fehler 
      }
      break;
  
    case 13:
      if (g.waschablauf.schnellwaesche){
        g.heizungsregelung.solltemperatur = g.waschablauf.waschtemperatur;
        NT_Aufheizen;
      }else{
        NT_Walken;
      }
      if (0==g.reversieren.anzahl){ //nach gut 1 Minute nochmal Wasserstand prfen
        g.reversieren.anzahl = 4;
#if TEST
        g.reversieren.anzahl = 1; 
#endif
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        status++;
      }
      break;
      
    case 14:
      if (0==g.reversieren.anzahl){ //Eine Minute spter nochmal Wasserstand prfen
        g.reversieren.anzahl = 2;  
        g.reversieren.wasserstandsanpassung = 1; //Wird automatisch zurckgesetzt
        status++;
      }
      break;
      
    //case 15..19 werden im Sekundentakt durchlaufen

    case 20:
      if (0==g.reversieren.anzahl){ 
        g.heizungsregelung.solltemperatur = TEMPERATUR_22; //Jetzt Heizung auf 22
        NT_Anwaermen;
        minuten=0;
        sekunden=0;
        g.reversieren.anzahl = 99;  
        g.reversieren.pausenzeit = 3;
        g.reversieren.drehzeit = 12;
        status++;
        if (g.waschablauf.schnellwaesche) status=25;
#if TEST
//        status = 36; //Heizen berspringen
        status=45;  //abkhlen berspringen
#endif
      }
      break;
      //Aufheizen bei Normalwasserstand und 8 Frischwasser dauert 5-8 Minuten
      //Hngt ab von der Maschinentemperatur und Wschemenge
      
    case 22: //Aufheizen auf 22C
      if (g.heizungsregelung.solltemperaturErreicht){
        NT_Walken;
        minuten=0;
        sekunden=0;
        g.reversieren.anzahl = 99;  
        g.reversieren.pausenzeit = 6;
        g.reversieren.drehzeit = 10;
        status++;
      }

    case 24://Wasche 8 Minuten bei 22
#if TEST
      if (minuten >= 1){ //Heizung auf Endtemperatur
#else
      if (minuten >= 8){ //8 Minuten spter: Heizung auf Endtemperatur
#endif
        status++;
      }
      break;


     case 25: //Erhhe auf Waschtemperatur
        NT_Aufheizen;
        g.reversieren.anzahl = 99;  // unendlich
        g.reversieren.pausenzeit = 3;
        g.reversieren.drehzeit = 14;
        g.heizungsregelung.solltemperatur = g.waschablauf.waschtemperatur;
        minuten=0;
        sekunden=0;
        status++;
      break;

    //case 26..27 werden im Sekundentakt durchlaufen
      
    case 28: //Reversieren, bis Solltemperatur erreicht (max. 30 Min.)
      g.reversieren.anzahl = 99;  // unendlich
      if ((minuten >30) || g.heizungsregelung.solltemperaturErreicht){
        g.reversieren.pausenzeit = 3;
        g.reversieren.drehzeit = 14;
        minuten=0;
        status++;
        if (g.waschablauf.schnellwaesche) status=33;
      }  
      break;

    //Zwischenschleudern ohne abpumpen um Lauge durch die Wsche zu drcken
    //wird in spsReversieren durch gelegentlich erhhte Drehzahl gemacht

    case 32: //Warmwaschphase 12 min. Dabei wird die Temperatur auf 1 konstant gehalten
      NT_Warmwaschen;
      
      g.reversieren.anzahl = 99;  // unendlich
      g.reversieren.pausenzeit = 3;
      g.reversieren.drehzeit = 12;
#if TEST
      if (minuten >=1){
#else
      if ((minuten >=12) || (g.waschablauf.schnellwaesche)) {  //Bei Schnellwsche: Heizung nach erreichen der Temperatur aus
#endif
        minuten=0;
        g.heizungsregelung.solltemperatur = 0; //Heizung aus
        status=36;
      }
      break;
    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    case 33: //Schnellwaschphase 10 min. Dabei ist die Heizung bereits aus
       //(Kommt von Status 28)
      NT_Nachwaschen;
      g.heizungsregelung.solltemperatur = 0; //Heizung aus
      g.reversieren.anzahl = 99;  // unendlich
      g.reversieren.pausenzeit = 12;
      g.reversieren.drehzeit = 8;
      if ((minuten >=10) ) {  
        minuten=0;
        status=40;
      }
      break;
    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

    case 36: //Nachwaschphase 25 min. Dabei bleibt die Heizung abgeschaltet.
      NT_Nachwaschen;
      g.reversieren.anzahl = 99;  // unendlich
      g.reversieren.pausenzeit = 12;
      g.reversieren.drehzeit = 8;
#if TEST
      if (minuten >=1) status++;
#else
      if (minuten >=25) status++;
#endif
      break;
  
    case 40: //    Abkhlphase    (Abkhlung der Wsche, um "Klteschock" im anschlieenden Splgang zu vermeiden) 
      //Reversieren mit kurzer Pausenzeit, dabei:
      // 3-7 Mal wiederholen (bis Temperatur unter 30): 
      //   Abpumpen auf 4/5 Wasserstand
      //   Wassereinlauf auf 5/5
      //   30s warten (dabei reversieren)

      //
      g.reversieren.anzahl = 0; 
      g.abkuehlen.freigabe = 1;
      NT_Abkuehlen;
      status++;
      break;

    case 41://Warte, bis abkhlen fertig
      if (!g.abkuehlen.freigabe) status++;
      break;

    case 45: //Nach dem Waschen: leicht schleudern
             //Nicht zu stark, sonst gibt's Waschmittelrnder
      g.reversieren.anzahl = 0; 
      g.trocknen.enddrehzahl = 600;
      g.trocknen.freigabe = 1;
      NT_Trocknen;
      status++;
      break;

    case 49: //Warte, bis Pumpen fertig
      if (!g.trocknen.freigabe){
        HT_Spuelgang1;
        NT_Leer;
        status++;
      }
      break;
      
    case 50: //Spuelgang
        //Splgang:
          //Wasser einlassen bis Splhhe (hoher Wasserstand)
          //10 min Reversieren mit kleinen Pausenzeiten

          //Abpumpen
          //Zwischenschleudern oder Endschleudern
        //Beim Weichsplen wird das Wasser ber die Weichsplkammer 
        //statt die Hauptwaschkammer eingesplt.
        

      switch (g.waschablauf.spuelgaenge){ //Wird je Splgang runtergezhlt
        case 0: //Fertig
          status = 55; //Auflockern
          break;
        
        case 1: //Letzter Splgang als Weichsplgang
          g.spuelgang.freigabe=0;
          g.weichspuelgang.freigabe=1;
          g.trocknen.enddrehzahl = g.waschablauf.endschleuderdrehzahl;
          g.waschablauf.Wasserniveau = 4; //Spuelen hoch
          HT_Weichspuel;
          NT_Leer;
          status++;
          break;
        
        default: //Nicht letzter Splgang
          g.trocknen.enddrehzahl = 700;
          g.spuelgang.freigabe=1;
          status++;
          break;
      }  //switch (g.waschablauf.spuelgaenge)
      break;
    
    case 51: //Warte, bis Splen fertig
      if ((!g.spuelgang.freigabe) && (!g.weichspuelgang.freigabe)){
        g.waschablauf.spuelgaenge--;
        status = 50;
        if (g.haupttextIndex<5) g.haupttextIndex++; //Nicht auf Schleudern gehen
        NT_Leer;
      }
      break;

        
    //55: Hierher springen, um 10s zu warten bis zum auflockern


    case 65: //Genug gesplt. Jetzt nur noch etwas die Wsche auflockern
      g.reversieren.anzahl=5;
      g.reversieren.pausenzeit = 8;
      g.reversieren.drehzeit = 15;
      status++;
      break;

    case 66:
      if (1==g.reversieren.anzahl){
        g.reversieren.drehzeit = 8;
        TUERVERRIEGELUNG_aus; //Dauert ja lange, bis die Tr entriegelt ist (thermische Bimetallverriegelung)
        status=86; //13s vor Ende
      }
      break;


    //--------- Sonderprogramme -----------

    case 70://Abpumpen, Tr auf
      HT_Sonder;
      NT_Pumpen;
      g.waschablauf.anfangswasserstand = 0x2c00; //Deutlich unter dem Messwert bei leerer Trommel
      g.abpumpen.nachlaufzeit=10;
      status++;
      break;

    case 71:
      if (!g.abpumpen.nachlaufzeit){
        status=99;
      }
      break;



    case 72://Abpumpen, Schleudern, Tr auf
      HT_Sonder;
      NT_Pumpen;
      TUERVERRIEGELUNG_ein;
      g.waschablauf.anfangswasserstand = 0x2c00; //Deutlich unter dem Messwert bei leerer Trommel
      status++;
      break;

    case 73:
      g.abpumpen.nachlaufzeit=10;
      status++;
      break;

    case 74:
      if (!g.abpumpen.nachlaufzeit){
        status++;
      }  
      break;
      //Etwas warten, bis Wassersensor eingeschwungen und Werte bermittelt
    case 78:
        g.waschablauf.anfangswasserstand = g.kleinhirnRecord.wasserstand;
        g.trocknen.freigabe=1;
        status++;
      break;
    case 79:
      NT_Trocknen;
      if (!g.trocknen.freigabe){
        status=99;
      }
      break;



    case 80:////Abpumpen, Splgang, Schleudern mit 700 Touren
      HT_Sonder;
      NT_Pumpen;
      TUERVERRIEGELUNG_ein;
      g.waschablauf.anfangswasserstand = 0x2c00; //Deutlich unter dem Messwert bei leerer Trommel
      g.abpumpen.nachlaufzeit=10;
      status++;
      break;

    case 81:
      if (!g.abpumpen.nachlaufzeit){
        status++;
      }  
      break;
    
    //Etwas warten, bis Wassersensor eingeschwungen und Werte bermittelt
    
    case 84:
        g.waschablauf.anfangswasserstand = g.kleinhirnRecord.wasserstand;
        g.spuelgang.freigabe=1;
        status++;
      break;

    case 85://Abpumpen, Splen, Tr auf
      if (!g.spuelgang.freigabe){
        status=99;
      }
      break;

    //case 86..98: Benutzt als Timer von case 61



    case 99: //Alles aus, unendlich Warten
      TUERVERRIEGELUNG_aus;
      HT_Ende;
      NT_Spruch;
    
      g.reversieren.anzahl=0;
      g.abpumpen.nachlaufzeit=0;
      g.abpumpen.intervallpumpen=0;
      g.heizungsregelung.solltemperatur=0;
      g.motor.solldrehzahl=0;
      g.schleudern.freigabe=0;
      g.trocknen.freigabe=0;
      g.abkuehlen.freigabe=0;

      VENTIL_VORWASCH_aus;
      VENTIL_HAUPTWASCH_aus;
      VENTIL_WEICHSPUEL_aus;
      LAUGENPUMPE_aus;
      g.waschablauf.fertig=1;
      break;



    case 100: //Biofilm-Reinigung (Aufheizen auf 85, reversieren, abpumpen (kein Schleudern)
      if (!g.biofilm.freigabe){
        status=99;
      }
      break;
    

    case 250: //Error
      //Fehlerbehandlung erfolgt am Ende von MAIN
      break;


    default:
      status++;  //Damit werden unbenutzte Stati im Sekundentakt weitergeschaltet
      break;
   
  }//switch (status)
}//spsWaschablauf


//--------------------------------------------------------
void startmeldung(void) {
//--------------------------------------------------------
//Versionsbezeichnung auf serieller Schnittstelle ausgeben
//Im Display ist die nicht zu sehen, da sie sofort vom Drehschaltertext 
//berschrieben wird. Aber bei einer Fehlersuche wird die
//serielle ber eine galvanisch getrennte RS232 an den PC angeschlossen
//und ich kann dann in HTERM sehen, ob ich den passenden Quellcode habe.
//
  char *buffer;
  char c;
  U8 i;

  buffer = txMsg;
  *buffer++ = '@';
  *buffer++ = 'c';  //Zeile 1
  i=0;
  while ((c = pgm_read_byte(&textStart[i])) != '\0') {
     *buffer++ = c;
		 i++;
  };
  *buffer = '\0';
  asm("wdr");  //Watchdog fttern
	sendstring(txMsg);

	buffer = txMsg;
  *buffer++ = '@';
  *buffer++ = 'H';  //Zeile 2
  buffer=showstr(buffer,"V2.12     ");  //  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  HIER VERSION EINTRAGEN <<<<<<<<<<<<<<<<<<<<
  buffer=showstr(buffer,__DATE__);     //Datum der Compilierung
  *buffer = '\0';
	sendstring(txMsg);
}//Startmeldung



//--------------------------------------------------------
int main (void)
//--------------------------------------------------------
{
static I16 i;
static U8 displaystatus;
static char *ram;
static U8 indexAusgabe, ticBisher, tic100ms;
static I16 dauer=0;
U8 nulldurchgaenge=0;

  cli();

  //-----------------------------------------------------
  //Watchdog einschalten
  //-----------------------------------------------------
  asm("wdr");
  MCUSR &= ~(1<<WDRF);
  WDTCSR |= (1<<WDCE | 1<<WDE);
  WDTCSR=(1<<WDE | 1<<WDP2 | 1<<WDP1); //Watchdog auf 1s

  //-----------------------------------------------------
  //Set up the 8-bit timer 0 (Startup timebase)
  //-----------------------------------------------------
  TCCR0A =  0; //Normaler Timer/Counter
  TCCR0B = (1<<CS02) | (1<<CS00); // Teiler 1:1024
  TIMSK0 = (1<<TOIE0); //Overflow Interrupt Enable,  berlauf alle 16ms

  
  //-----------------------------------------------------
  //Set up the 16-bit timer 1 (Tacho)
  //-----------------------------------------------------
  //Tacho-Signal an ICP1 pin (Using the Input Capture Unit)
  
  TCCR1A =  0; //Normaler Timer/Counter
  TCCR1B =  (1<<ICNC1)  //Input Capture Noise Canceler
          | (1<<ICES1)  //Trigger on rising edge
          | (1<<CS12)   //Prescaler=256, Takt=16.384MHz, Zhlfrequenz:64KHz
          ;
/*         CS12 CS11 CS10 Description
            0    0    0    No clock source (Timer/Counter stopped).
            0    0    1    clk /1 (No prescaling)
            0    1    0    clk /8 (From prescaler)
            0    1    1    clk /64 (From prescaler)
            1    0    0    clk /256 (From prescaler)
            1    0    1    clk /1024 (From prescaler)
            1    1    0    External clock source on T1 pin. Clock on falling edge.
            1    1    1    External clock source on T1 pin. Clock on rising edge.
*/
  //Timer Interrupt Mask
  TIMSK1 = (1<<ICIE1) //Timer 1 Input Capture
          |(1<<TOIE1) //Overflow Interrupt Enable
          ;


  //-----------------------------------------------------
  //Set up the 8-bit timer 2  (Triac-Znd Generator)
  //-----------------------------------------------------
  //Timer wird in 50Hz Interrupt eingestellt!
  TCCR2A =0;  //  Normal Modus

  OCR2A = 150; //Triac+Timer lschen
  OCR2B = 160; //Zndzeitpunkt. 160 Wird nie erreicht.
  TCCR2B = 0; //Timer erstmal aus.
  TCNT2  = 0;
  TIMSK2 = (1<<OCIE2A)|(1<<OCIE2B);  //Timer 2 Output Compare Match.  Geht auf TIMER2_COMPA_vect und TIMER2_COMPB_vect



/*

                PC6 1  28 PC5   Rechts
            Rx  PD0 2  27 PC4   Triac Motor
            Tx  PD1 3  26 PC3   Ventil Weichspl
  Nulldurchgang PD2 4  25 PC2   Ventil Hauptwasch
                PD3 5  24 PC1   Ventil Vorsplen
Trverriegelung PD4 6  23 PC0   Relais Heizung
                VCC 7  22 GND
                GND 8  21 AREF
             Q1 PB6 9  20 AVCC
             Q2 PB7 10 19 PB5   SCK   
                PD5 11 18 PB4   MISO  
        Schnell PD6 12 17 PB3   MOSI  
                PD7 13 16 PB2   Laugenpumpe
          Tacho PB0 14 15 PB1   Links
*/
  //-----------------------------------------------------
  // Ports konfigurieren
  //-----------------------------------------------------
  DDRB = BIT1|BIT2;  //Links, Laugenpumpe
  PORTB = BIT3|BIT4|BIT5; //Pull-Up Widerstnde ein

  DDRC = BIT0|BIT1|BIT2|BIT3|BIT4|BIT5; //Heizung, Wei, Schwarz, Rosa, TriacMotor, Rechts
  PORTC = 0; //alles AUS

  DDRD = BIT4; //Trverriegelung
  PORTD = BIT3|BIT5; // Pull-Up Widerstnde ein 
 
  EICRA=(1<<ISC00); //External interrupt INT0 (PD2) bei wechselnder Flanke  (Nulldurchgang) (S.72)
  EIMSK=(1<<INT0);

    
  //-----------------------------------------------------
  // RS232 konfigurieren
  //-----------------------------------------------------
  USART_Init();

  //-----------------------------------------------------
  // Globale Variablen initialisieren
  //-----------------------------------------------------
//    memset(&g, 0, sizeof(Tglob));               Da rastet der Chip aus
  ram=(char *)&g;
  for (i=0; i< sizeof(Tglob); ram[i++]=0);   //Mach ich's halt von Hand

  g.motor.cZuendzeit=120;  //entspricht AUS
  indexAusgabe=0;
  displaystatus=0;
  g.programmNochNichtFestgelegt = 26;

  //-----------------------------------------------------
  //Interrupts EIN.
  //-----------------------------------------------------
  sei(); // Jetzt geht's los!
  asm("wdr");  //Watchdog fttern


  TIFR1 |=1; //Reset Overflow-Flag on Timer1


  while (g.tic112ms <44){ //in den ersten 5 Sekunden: Nichts machen als Startmeldung und Drehschalter anzeigen
    asm("wdr");  //Watchdog fttern
    receiveTelegramm(); //Daten vom Kleinhirn

    switch (displaystatus){
      case 0: //Warte, bis Display sich initialisiert hat
        if (g.tic112ms > 1) displaystatus++;
        break;

      case 1: //Startmeldung ausgeben
        startmeldung();
        displaystatus++;
        break;

      case 2: //Meldung 1 Takt stehen lassen 
        if (g.tic112ms > 3) displaystatus++;
        break;

      case 3: //Drehschalterstellung anzeigen (falls empfangen) 
        if (g.kleinhirnSendet){
          g.kleinhirnSendet=0;
          programmtextDisplay();	
        }
        ticBisher = g.tic112ms;
        displaystatus++;        
        break;

      case 4: //Warte, bis Takt um
        //Teste, ob Nulldurchgangs-Interrupts kommen (sonst darf ich den Motor nicht anwerfen)
        if (g.next100ms){      //Alle 100ms in Nulldurchgang gesetzt
          nulldurchgaenge++;
        }
        g.next100ms=0;


        if (ticBisher != g.tic112ms){
          displaystatus=3;
          if (g.programmNochNichtFestgelegt){
            g.programmNochNichtFestgelegt--;
            if (g.tic112ms > 40) g.tic112ms=40;
          }          
        }
        break;
      case 5: //Wird nie erreicht. Nur damit der Optimizer nicht den Code in Status 3 rauswirft.
        g.kleinhirnSendet=1;
        break;

    }
  }
  g.tic112ms=0;

//  showval(txMsg, "\nRX=",3,g.empfangeneTelegramme); sendstring(txMsg);

  //-----------------------------------------------------
  // Kommen Daten vom Kleinhirn? Kommen Nulldurchgangsinterrupts?
  //-----------------------------------------------------
  
  if (g.empfangeneTelegramme < 2) g.error=7;
  else
  if (nulldurchgaenge < 10)  g.error = 10;  //Kein Nulldurchgang

  if (g.error){//Wir haben eine Fehlermeldung!
    errortext(txMsg, g.error);
    sendstring(txMsg);
  } 

  while (g.error){ 
    asm("wdr");  //Watchdog fttern
    LAUGENPUMPE_ein;     //Im Fehlerfall: auf jeden Fall 11s Pumpen
    if (g.tic112ms >99) break; //Code-Rumgetrickse: Der Test darf nicht in der while() Bedingung sein, da mir der Optimizer den Code sonst wegoptimiert
  }

  //Zeitgeber aus (wird nicht mehr gebraucht, da Zeitbasis nun die Netzfreqenz ist)
  TCCR0B = 0;
  TIMSK0 = 0;


//DEBUG Kleinhirn:
#if 0
  while(1){
    asm("wdr");  //Watchdog fttern
    if ( RxDataAvail() ) USART_Transmit(RxDataGetByteFast());
  }
#endif

  //-----------------------------------------------------
  // Defaultwerte setzen
  //-----------------------------------------------------
  g.waschablauf.waschtemperatur = TEMPERATUR_40;
  g.trocknen.enddrehzahl = 800;
  g.waschablauf.Wasserniveau=0;    //0=normal 1=hoch 2=Wolle
  g.waschablauf.spuelgaenge=2;     //Normal 3, bei Schnellwaesche 2
  g.waschablauf.anfangswasserstand = 0x2c00; //Deutlich unter dem Messwert 0x2cac bei leerer Trommel

  g.pSendChar=txMsg;
  *g.pSendChar=0;



  g.kleinhirnSendet=30; //Vorbeugen, damit nicht sofort ein Fehler gemeldet wird
//----------------------------------------------------------------------------------
  while(1){  // Endlosschleife - wird nur im Fehlerfall verlassen
//----------------------------------------------------------------------------------
    asm("wdr");  //Watchdog fttern
    if (g.error) break;
    receiveTelegramm(); //Daten vom Kleinhirn
    berechneUnwucht();

    if (!g.Reglerschritt){
      g.Reglerschritt=1;
      spsMotor();
      asm("wdr");  //Watchdog fttern
    }

    if (g.next100ms){      //Alle 100ms (In Nulldurchgang gesetzt)
      g.next100ms=0;

      tic100ms++;

      if (5==tic100ms) spsReversieren();
      if (10==tic100ms){
        tic100ms=0;
        spsReversieren();
        spsSekundentakt();
        
        //Plausibilittscheck der Temperatur
        if (g.kleinhirnRecord.temperatur >=999){
          g.error=8; //Error Thermofuehler
        }
        //Plausibilittscheck des Wasserstandes
        if (0==g.kleinhirnRecord.wasserstand){
          g.error=9; //Error Druckmessdose
        }
        if (!g.waschablauf.fertig){
          dauer++;
          if (59==(dauer % 60))  g.uptimeM++;
        }
      }

      if (g.kleinhirnSendet){
        g.kleinhirnSendet--;
      }else{
        g.error=7; //Keine Daten vom Kleinhirn
      }

      spsSchleudern();

    }//next100ms 



    //ggf. Zeichen zum Display senden
    if (
             (UCSR0A & (1<<UDRE0))   //Senderegister bereit, wenn UDRE0 gesetzt
          && (*g.pSendChar)          //Nicht am Stringende
       )
    {   
      UDR0 = *g.pSendChar++;  //Sende ein Zeichen
    } 
    
  }  //while 1

  //-----------------------------------------------------
  // Wir haben eine Fehlermeldung!
  //-----------------------------------------------------

  errortext(txMsg, g.error);

  while(1){
    asm("wdr");  //Watchdog fttern
    sendstring(txMsg); //zyklisch senden, um Display-Timeout zu verhindern

    //Alles abschalten, aber die Tr bleibt verriegelt (Falls sie es war)!
    VENTIL_VORWASCH_aus;
    VENTIL_HAUPTWASCH_aus;
    VENTIL_WEICHSPUEL_aus;
    TROMMELMOTOR_TRIAC_aus;
    RELAIS_RECHTS_aus;
    RELAIS_LINKS_aus;
    RELAIS_SCHNELL_aus;
    RELAIS_HEIZUNG_aus;
#if 0
    //Vorbeugen gegen undichtes Magnetventil
    if (g.kleinhirnRecord.wasserstand > WASSERSTAND_NORMAL){
      LAUGENPUMPE_ein;    
    }else 
    if (g.kleinhirnRecord.wasserstand < WASSERSTAND_1){
      LAUGENPUMPE_aus;    
    };
#else
    LAUGENPUMPE_aus;    
#endif    
    //Warte watchdogftternderweise
    asm("wdr");  
    _delay_ms(800);
    asm("wdr");  
    _delay_ms(800);
    asm("wdr");  
    _delay_ms(800);
    asm("wdr");  
    _delay_ms(800);
  }
  return (0);

}


//EOF
